unit UnitPalette;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,UnitPrinc;

{const
      TaillePalette = 1800;
      nombreDePalettes = 6;

type
TableCouleur     = array[0..TaillePalette,1..3] of Byte;
Palette          = record
                   Couleur  : array[0..TaillePalette,1..3] of Byte;
                   Nombre,pas,depart   : integer;
                   BorneMin,BorneMax : Double;
                   SaturationMin,SaturationMax : Double;
                   style : byte;
                         //  0 <=> satur
                         //  1 <=> Cycle
                         //  2 <=> modulo
                   end;
TablePalette     = array[1..nombreDePalettes] of Palette;}

type
  TFormPalette = class(TForm)
    EditPas: TEdit;
    Label1: TLabel;
    ButtonCharger: TButton;
    EditSatMin: TEdit;
    Label2: TLabel;
    EditSatMax: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    ComboBoxStyle: TComboBox;
    OpenDialog1: TOpenDialog;
    Label5: TLabel;
    Label6: TLabel;
    Supprimer: TButton;
    Label7: TLabel;
    EditBorneMin: TEdit;
    EditBorneMax: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    UpDown1: TUpDown;
    ButtonRemplacer: TButton;
    ScrollBar1: TScrollBar;
    procedure FormCreate(Sender: TObject);
    procedure ButtonChargerClick(Sender: TObject);
    procedure SupprimerClick(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure ButtonRemplacerClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FormPalette: TFormPalette;

  {TableauPalette     : TablePalette;
  NbPalettes       : Byte;
  PaletteCourante  : Byte;}

implementation

{$R *.DFM}
//uses  UnitPrinc;


function HexadecimalToDecimal(nb:String):Byte;
var a,s : byte;
begin
a := Ord(nb[2]);
if a<=58 then s := a-48 else s := a-55;
a := Ord(nb[1]);
if a<=58 then s := s+16*(a-48) else s := s+16*(a-55);
HexadecimalToDecimal := s;
end;

procedure TFormPalette.FormCreate(Sender: TObject);
begin
ComboBoxStyle.ItemIndex := 0;
//FormPalette.EditSatMin.Text := '3';
//FormPalette.EditSatMax.Text := '75';
end;

procedure TFormPalette.ButtonChargerClick(Sender: TObject);
var  F : TextFile;
     S,S1 : String;
     c,k : Integer;
begin
if OpenDialog1.Execute then
  begin
  AssignFile(F,OpenDialog1.FileName);
  Reset(F);

  for k := NbPalettes downto PaletteCourante do
    begin
    for c:=0 to TableauPalette[k].IndiceMax do
       begin
       TableauPalette[k+1].Couleur[c,1]  := TableauPalette[k].Couleur[c,1];
       TableauPalette[k+1].Couleur[c,2]  := TableauPalette[k].Couleur[c,2];
       TableauPalette[k+1].Couleur[c,3]  := TableauPalette[k].Couleur[c,3];
       end;
    TableauPalette[k+1].Nom           := TableauPalette[k].Nom;
    TableauPalette[k+1].IndiceMax     := TableauPalette[k].IndiceMax;
    TableauPalette[k+1].Pas           := TableauPalette[k].pas;
    TableauPalette[k+1].style         := TableauPalette[k].style;
    TableauPalette[k+1].depart        := TableauPalette[k].depart;
    TableauPalette[k+1].SaturationMin := TableauPalette[k].saturationMin;
    TableauPalette[k+1].SaturationMax := TableauPalette[k].saturationMax;
    TableauPalette[k+1].BorneMin      := TableauPalette[k].BorneMin;
    TableauPalette[k+1].BorneMax      := TableauPalette[k].BorneMax;
    end;

  S := OpenDialog1.FileName;
  k := length(S)-4;
  S1 := '';
  while (k > 0) and (S[k]<> '\') do
    begin
    S1 := S[k] + S1;
    k := k-1;
    end;

  TableauPalette[PaletteCourante].Nom      := S1;
  TableauPalette[PaletteCourante].Pas      := 1;
  TableauPalette[PaletteCourante].style    := 0;
  TableauPalette[PaletteCourante].depart   := 0;
  //TableauPalette[PaletteCourante].BorneMin := TableauPalette[PaletteCourante+1].BorneMin;
  TableauPalette[PaletteCourante].BorneMax :=
    (TableauPalette[PaletteCourante].BorneMin+TableauPalette[PaletteCourante+1].BorneMax)/2;
  TableauPalette[PaletteCourante+1].BorneMin := TableauPalette[PaletteCourante].BorneMax;
  TableauPalette[PaletteCourante].SaturationMin := TableauPalette[PaletteCourante].BorneMin;
  TableauPalette[PaletteCourante].SaturationMax := TableauPalette[PaletteCourante].BorneMax;
  TableauPalette[PaletteCourante+1].SaturationMin := TableauPalette[PaletteCourante+1].BorneMin;
  TableauPalette[PaletteCourante+1].SaturationMax := TableauPalette[PaletteCourante+1].BorneMax;
  Inc(NbPalettes);
  c := 0;
  while not EOF(F) do
    begin
    ReadLn(F, S);
    TableauPalette[PaletteCourante].Couleur[c,1] := HexadecimalToDecimal(S[1]+S[2]);
    TableauPalette[PaletteCourante].Couleur[c,2] := HexadecimalToDecimal(S[3]+S[4]);
    TableauPalette[PaletteCourante].Couleur[c,3] := HexadecimalToDecimal(S[5]+S[6]);
    Inc(c);
    end;

  Label7.Caption := S1 + ' ' + '(' +
                    IntToStr(PaletteCourante) + '/' +
                    IntToStr(NbPalettes) +')';

  TableauPalette[PaletteCourante].IndiceMax := c-1;
  FormPalette.EditPas.Text := IntToStr(TableauPalette[PaletteCourante].Pas);
  FormPalette.ComboBoxStyle.ItemIndex := TableauPalette[PaletteCourante].style;
  FormPalette.ScrollBar1.Position :=
     Round(TableauPalette[PaletteCourante].depart/
           TableauPalette[PaletteCourante].IndiceMax*100);
  FormPalette.EditBorneMin.Text := FloatToStr(TableauPalette[PaletteCourante].BorneMin);
  FormPalette.EditBorneMax.Text := FloatToStr(TableauPalette[PaletteCourante].BorneMax);
  FormPalette.EditSatMin.Text := FloatToStr(TableauPalette[PaletteCourante].SaturationMin);
  FormPalette.EditSatMax.Text := FloatToStr(TableauPalette[PaletteCourante].SaturationMax);
  CloseFile(F);
  end;
end;

procedure TFormPalette.SupprimerClick(Sender: TObject);
var k : Integer;
begin
if (NbPalettes > 1) then
  begin
  NbPalettes := NbPalettes - 1 ;
  if (PaletteCourante < NbPalettes) then
     begin
     for k := PaletteCourante to NbPalettes do
        begin
        TableauPalette[k].Nom      := TableauPalette[k+1].Nom;
        TableauPalette[k].Pas      := TableauPalette[k+1].Pas;
        TableauPalette[k].style    := TableauPalette[k+1].style;
        TableauPalette[k].depart   := TableauPalette[k+1].depart;
        TableauPalette[k].SaturationMin := TableauPalette[k+1].saturationMin;
        TableauPalette[k].SaturationMax := TableauPalette[k+1].saturationMax;
        TableauPalette[k].BorneMin      := TableauPalette[k+1].BorneMin;
        TableauPalette[k].BorneMax      := TableauPalette[k+1].BorneMax;
        end;
     if (PaletteCourante > 1) then
         TableauPalette[PaletteCourante].BorneMin := TableauPalette[PaletteCourante-1].BorneMax
                              else
         TableauPalette[PaletteCourante].BorneMin := min;
     end
     else
     begin
     PaletteCourante := PaletteCourante - 1 ;
     TableauPalette[PaletteCourante].BorneMax := max;
     Updown1.Position := PaletteCourante;
     end;
  Label7.Caption := TableauPalette[PaletteCourante].Nom + ' ' + '(' +
                    IntToStr(PaletteCourante) + '/' +
                    IntToStr(NbPalettes) +')';
  FormPalette.EditPas.Text := IntToStr(TableauPalette[PaletteCourante].Pas);
  FormPalette.ComboBoxStyle.ItemIndex := TableauPalette[PaletteCourante].style;
  FormPalette.ScrollBar1.Position :=
     Round(TableauPalette[PaletteCourante].depart/
           TableauPalette[PaletteCourante].IndiceMax*100);
  FormPalette.EditBorneMin.Text := FloatToStr(TableauPalette[PaletteCourante].BorneMin);
  FormPalette.EditBorneMax.Text := FloatToStr(TableauPalette[PaletteCourante].BorneMax);
  FormPalette.EditSatMin.Text := FloatToStr(TableauPalette[PaletteCourante].SaturationMin);
  FormPalette.EditSatMax.Text := FloatToStr(TableauPalette[PaletteCourante].SaturationMax);
  end;
end;

procedure TFormPalette.UpDown1Click(Sender: TObject; Button: TUDBtnType);
var c : Integer;
begin
c := Updown1.Position;

if (c = 0) then Updown1.Position := 1
  else
  if (c > NbPalettes) then Updown1.Position := NbPalettes
     else
     begin
     PaletteCourante := c;
     Label7.Caption :=  TableauPalette[PaletteCourante].Nom + ' ' + '(' +
                    IntToStr(PaletteCourante) + '/' +
                    IntToStr(NbPalettes) +')';
     FormPalette.EditPas.Text := IntToStr(TableauPalette[PaletteCourante].Pas);
     FormPalette.ComboBoxStyle.ItemIndex := TableauPalette[PaletteCourante].style;
     FormPalette.ScrollBar1.Position :=
     Round(TableauPalette[PaletteCourante].depart/
           TableauPalette[PaletteCourante].IndiceMax*100);
     FormPalette.EditBorneMin.Text := FloatToStr(TableauPalette[PaletteCourante].BorneMin);
     FormPalette.EditBorneMax.Text := FloatToStr(TableauPalette[PaletteCourante].BorneMax);
     FormPalette.EditSatMin.Text := FloatToStr(TableauPalette[PaletteCourante].SaturationMin);
     FormPalette.EditSatMax.Text := FloatToStr(TableauPalette[PaletteCourante].SaturationMax);
     end;
end;

procedure TFormPalette.ButtonRemplacerClick(Sender: TObject);
var c : Integer;
    S,S1 : String;
    F : TextFile;
begin
if OpenDialog1.Execute then
  begin
  AssignFile(F,OpenDialog1.FileName);
  Reset(F);
  S := OpenDialog1.FileName;
  c := length(S)-4;
  S1 := '';
  while (c > 0) and (S[c]<> '\') do
    begin
    S1 := S[c] + S1;
    c := c-1;
    end;


  Label7.Caption := S1 + ' ' + '(' +
                    IntToStr(PaletteCourante) + '/' +
                    IntToStr(NbPalettes) +')';


  TableauPalette[PaletteCourante].Nom      := S1;
  TableauPalette[PaletteCourante].Pas      := 1;
  TableauPalette[PaletteCourante].style    := 0;
  TableauPalette[PaletteCourante].depart   := 0;

  c := 0;
  while not EOF(F) do
    begin
    ReadLn(F, S);
    TableauPalette[PaletteCourante].Couleur[c,1] := HexadecimalToDecimal(S[1]+S[2]);
    TableauPalette[PaletteCourante].Couleur[c,2] := HexadecimalToDecimal(S[3]+S[4]);
    TableauPalette[PaletteCourante].Couleur[c,3] := HexadecimalToDecimal(S[5]+S[6]);
    Inc(c);
    end;

  TableauPalette[PaletteCourante].IndiceMax := c-1;
  CloseFile(F);
  end;

end;



procedure TFormPalette.ScrollBar1Change(Sender: TObject);
begin
{VerificationPalette(TableauPalette);
TableauPalette[PaletteCourante].pas := StrToInt(FormPalette.EditPas.Text);
TableauPalette[PaletteCourante].style := FormPalette.ComboBoxStyle.ItemIndex;
TableauPalette[PaletteCourante].depart :=
   Round(FormPalette.ScrollBar1.Position/100*TableauPalette[PaletteCourante].Nombre);
//TableauPalette[PaletteCourante].BorneMin := StrToFloat(FormPalette.EditBorneMin.Text);
//TableauPalette[PaletteCourante].BorneMax := StrToFloat(FormPalette.EditBorneMax.Text);
TableauPalette[PaletteCourante].SaturationMin   := StrToFloat(FormPalette.EditSatMin.Text);
TableauPalette[PaletteCourante].SaturationMax   := StrToFloat(FormPalette.EditSatMax.Text);



DessineImage(NewPict,TableauPalette,NbPalettes,Image1); }
end;

end.
