unit UnitPrinc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, ExtDlgs, ComCtrls, Math, ImgList, ToolWin;

const Taille256        = 255;
      Taille512        = 511;
      Taille1024       = 1023;
      Taille2048       = 2047;
      MaxAppliAff      = 16;
      MaxAppliD        = 10000;
      Pii              = 3.141592653589793238462;
      Pi2              = 6.283185307179586476925;
      MaxRacine        = 20;
      NbZoom           = 25;
      TaillePalette    = 1800;
      nombreDePalettes = 6;
      incertitude      = 1e-13;

type
    Effet            = (aucun,relief,hollowValue,contrast);
    TypeMatrice      = (entier,reel);
    TypeSuite        = (simple,recurrente);
    TypeFractal      = (FMandelbrot,FJulia);
    TypeSymetrie     = (none,OxOy,Zn,Dn);
    EDiverge         = class(Exception);
    PImageE256       = ^ImageE256;
    PImageR256       = ^ImageR256;
    ImageE256        = array[0..Taille256,0..Taille256]   of Longint;
    ImageR256        = array[0..Taille256,0..Taille256]   of Double;
    NImageE          = array[0..7,0..7]                   of PImageE256;
    NImageR          = array[0..7,0..7]                   of PImageR256;
    MatriceReelle    = array of array of Double;
    MatriceEntiere   = array of array of LongInt;
    NewImage         = record
                       Format : TypeMatrice;
                       tE : MatriceEntiere;
                       tR : MatriceReelle;
                       end;
    TabFamilleAppli  = array[1..MaxAppliAff,1..7] of Double;

    FamilleAppli     = record
                       TabFamApp : TabFamilleAppli;
                       NbApp     : Integer;
                       end;
    FamilleAppliD    = record
                       TabFamAppD : array[0..MaxAppliD,1..3] of Double;
                       NbApp      : Integer;
                       typeSym    : TypeSymetrie;
                       degre      : Integer;
                       Nom        : String;
                       end;

    Date             = record
                       minutes  : Longint;
                       secondes,millisecondes : Integer;
                       end;

    Palette          = record
                       Nom : String;
                       Couleur  : array[0..TaillePalette,1..3] of Byte;
                       IndiceMax,pas,depart   : Longint;
                       BorneMin,BorneMax : Double;
                       SaturationMin,SaturationMax : Double;
                       style : byte;
                         //  0 <=> satur
                         //  1 <=> Cycle
                         //  2 <=> modulo
                       end;
   TablePalette     = array[1..nombreDePalettes] of Palette;

  TypeNoeud = (cte, variable, OpUnaire,OpBinaire);
  UnOpUnaire = (Fmoins,Fplus,Fsin,Fcos,Ftan,Farcsin,Farccos,Farctan,
                 Fsh,Fch,Fth,Fargsh,Fargch,Fargth,Fabs,Fint,Ffrac,Fexp,
                 Fln,Flog,Fsqrt,Fsqr,Fflip,Fconj);
  UnOpBinaire =(Fsom,Fsou,Fmul,Fdiv,Fpui);
  PtNoeud = ^Noeud;
  Noeud =
    record
    gauche,droite : PtNoeud;
    case typ : TypeNoeud of
       cte      : (valeur   : Double);  // 0 <-> A  et 1 <-> C
       variable  : (rang    : Byte);  // 2 <-> x0 et 3 <-> y et 4 <-> x
       OpUnaire  : (oper1   : UnOpUnaire);
       OPBinaire : (oper2   : UnOpBinaire);
    end;

  Fonction = Noeud;

  complexe = array[1..2] of Extended;

  PtNoeudC = ^NoeudC;
  NoeudC =
    record
    gauche,droite : PtNoeudC;
    case typ : TypeNoeud of
       cte      : (valeur   : complexe);
       variable  : (rang    : Byte);  // 1 <-> c  5 <-> z0 6 <-> z
       OpUnaire  : (oper1   : UnOpUnaire);
       OPBinaire : (oper2   : UnOpBinaire);
    end;

  FonctionC = NoeudC;


const OperateursUnaires : array[UnOpUnaire] of string[6] =
     ('-','+','sin','cos','tan','arsin','arccos','arctan','sh','ch',
      'th','argsh','argch','argth','abs','int','frac','exp','ln','log',
      'sqrt','sqr','flip','conj');

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Taille1: TMenuItem;
    Outils1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    N256x2561: TMenuItem;
    N512x5121: TMenuItem;
    N1024x10241: TMenuItem;
    N2048x20481: TMenuItem;
    FFT: TMenuItem;
    Aide1: TMenuItem;
    Aproposde1: TMenuItem;
    Type1: TMenuItem;
    MandelbrotetCo1: TMenuItem;
    IFSetCo1: TMenuItem;
    AttracteuretCo1: TMenuItem;
    Oribte1: TMenuItem;
    Mandelbrot1: TMenuItem;
    Julia1: TMenuItem;
    Mandelbrot21: TMenuItem;
    Julia21: TMenuItem;
    MandelbrotRec21: TMenuItem;
    JuliaRec21: TMenuItem;
    Applilin1: TMenuItem;
    ApplideD1: TMenuItem;
    Carr1: TMenuItem;
    Symlin1: TMenuItem;
    MandelbrotdeK1: TMenuItem;
    JuliadeK1: TMenuItem;
    Etat1: TMenuItem;
    Cadre1: TMenuItem;
    Palette1: TMenuItem;
    Ferguson11: TMenuItem;
    Ferguson31: TMenuItem;
    Execution1: TMenuItem;
    ImageM: TMenuItem;
    Paramtres1: TMenuItem;
    Repartition1: TMenuItem;
    MarKus1: TMenuItem;
    Couleur1: TMenuItem;
    SymtriqueNonPoly1: TMenuItem;
    IFS1: TMenuItem;
    SavePictureDialog1: TSavePictureDialog;
    Sauver1: TMenuItem;
    logistique1: TMenuItem;
    Image1: TImage;
    RetourZoom1: TMenuItem;
    StatusBar1: TStatusBar;
    Distribution1: TMenuItem;
    FergusonG1: TMenuItem;
    General1: TMenuItem;
    Henon1: TMenuItem;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Relief1: TMenuItem;
    Hollow1: TMenuItem;
    Contrast1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Build1: TMenuItem;
    Cancel1: TMenuItem;
    test1: TMenuItem;
    procedure Quitter1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N256x2561Click(Sender: TObject);
    procedure N512x5121Click(Sender: TObject);
    procedure N1024x10241Click(Sender: TObject);
    procedure N2048x20481Click(Sender: TObject);
    procedure Mandelbrot1Click(Sender: TObject);
    procedure Julia1Click(Sender: TObject);
    procedure Mandelbrot21Click(Sender: TObject);
    procedure Julia21Click(Sender: TObject);
    procedure MandelbrotdeK1Click(Sender: TObject);
    procedure JuliadeK1Click(Sender: TObject);
    procedure MandelbrotRec21Click(Sender: TObject);
    procedure JuliaRec21Click(Sender: TObject);
    procedure Applilin1Click(Sender: TObject);
    procedure ApplideD1Click(Sender: TObject);
    procedure Carr1Click(Sender: TObject);
    procedure Symlin1Click(Sender: TObject);
    procedure Cadre1Click(Sender: TObject);
    procedure ImageMClick(Sender: TObject);
    procedure Repartition1Click(Sender: TObject);
    procedure Palette1Click(Sender: TObject);
    procedure Couleur1Click(Sender: TObject);
    procedure Paramtres1Click(Sender: TObject);
    procedure SymtriqueNonPoly1Click(Sender: TObject);
    procedure Ferguson11Click(Sender: TObject);
    procedure Henon1Click(Sender: TObject);
    procedure Sauver1Click(Sender: TObject);
    procedure logistique1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RetourZoom1Click(Sender: TObject);
    procedure Ferguson31Click(Sender: TObject);
    procedure Distribution1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Aproposde1Click(Sender: TObject);
    procedure FergusonG1Click(Sender: TObject);
    procedure General1Click(Sender: TObject);
    procedure Aide1Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure Relief1Click(Sender: TObject);
    procedure Hollow1Click(Sender: TObject);
    procedure Contrast1Click(Sender: TObject);
    procedure Build1Click(Sender: TObject);
    procedure Cancel1Click(Sender: TObject);
    procedure test1Click(Sender: TObject);
  private
    { Dclarations prives }
  public


    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  PointMouvant,ancPt,nvPt,CouPt : TPoint;
  BoutonEnfonce,CadreCree,OverallMovement : Boolean;
  ancX,ancY,cadreModifie : Integer;
  BoutonSouris : TMouseButton;

  ProgrammeCourant : Word;
  TailleCourante   : Integer;
  TableauPalette     : TablePalette;
  NbPalettes       : Byte;
  PaletteCourante  : Byte;
  FamilleApplicationCourante : Byte; // pour les IFS linaires symtriques
  NewPict : NewImage;
  Auxi : MatriceEntiere;
  min,max,minEffet,maxEffet : Double;
  FamilleApplication : FamilleAppli;
  FamilleD : FamilleAppliD;
  coordonnees : array[0..NbZoom,1..4] of Extended;
  coordonneesCourante : Byte;
  Dinitiale,Dfinale : Date;
  f1 : Fonction;
  fC : FonctionC;
  CreationArbre,CreationArbreC,erreur,ObjetCalcule : Boolean;
  aEclair,bEclair,cEclair,Kintensite,phi,theta : double;
  lEffet : effet;

implementation

uses UnitMandel, UnitCadre, UnitRepartition, UnitPalette,UnitIFSlin,
     UnitAttrSym,UnitIconeCarre,UnitFerguson,UnitD,UnitMarkus,
     UnitFergusonGeneral,UnitAbout,UnitMJGeneral,UnitListFunc,
     UnitListFuncHenon,UnitEffet;

{$R *.DFM}

function modMath(a, m : Longint):Longint;
begin
if (a>=0) or (a mod m = 0) then modMath := a mod m
        else modMath := m + (a mod m)
end;

function divMath(a, m : Longint):Longint;
begin
if (a>=0) or (a mod m = 0) then divMath := a div m
                           else divMath := a div m -1
end;

Function ParFrac(X:Double):Double;
var Aux : Double;
begin
Aux := Frac(X);
if Aux < 0 then ParFrac := Aux+1 else ParFrac := Aux;
end;

procedure RGBToHSV(R,G,B : Double;var H,S,V : Double);
var Aux : Double;
begin
if ((R=G) and (G=B)) then
  begin
  H := -1;
  S := 0;
  V := R
  end
  else
  begin
  if (R <> B) then
    begin
    Aux := 60*(G-B)/(R-B);
    if (Aux >= 0) and (Aux < 60) then
      begin
      if (R<>0) and (R >= B) then
        begin
        H := Aux;
        S := (R-B)/R;
        V :=  R;
        Exit
        end
        else
        begin
        H := 180+Aux;
        S := (B-R)/B;
        V :=  B;
        Exit
        end
      end
    end;
  if (B <> G) then
    begin
    Aux := 60*(R-G)/(B-G);
    if (Aux >= 0) and (Aux < 60) then
      begin
      if (G<>0) and (G >= B) then
        begin
        H := 60+Aux;
        S := (G-B)/G;
        V :=  G;
        Exit
        end
        else
        begin
        H := 240+Aux;
        S := (B-G)/B;
        V :=  B;
        Exit
        end
      end
    end;
  Aux := 60*(B-R)/(G-R);
  if (G<>0) and (G >= R) then
        begin
        H := 120+Aux;
        S := (G-R)/G;
        V :=  G;
        Exit
        end
        else
        begin
        H := 300+Aux;
        S := (R-G)/R;
        V :=  R;
        Exit
        end
  end  {de la fin}

end;

procedure HSVToRGB(H,S,V : Double;var R,G,B : Double);
begin
if (H=-1) then
  begin
  R := V;
  G := V;
  B := V;
  end
  else
  if (0<=H) and (H<60) then
    begin
    R := V ;
    G := V*(1+S*(H/60-1));
    B := V*(1-S)
    end
    else if (H<120) then
    begin
    R := V*(1+S*(1-H/60));
    G := V;
    B := V*(1-S)
    end
    else if (H<180) then
    begin
    R := V*(1-S);
    G := V;
    B := V*(1+S*(H/60-3))
    end
    else if (H<240) then
    begin
    R := V*(1-S);
    G := V*(1+S*(3-H/60));
    B := V
    end
    else if (H<300) then
    begin
    R := V*(1+S*(H/60-5));
    G := V*(1-S);
    B := V
    end
    else
    begin
    R := V;
    G := V*(1-S);
    B := V*(1+S*(5-H/60))
    end
end;


function Contractante(var T : FamilleAppli):Boolean;
var k : Byte;
    a,b,c : Double;
begin
Contractante := True;
for k := 1 to T.NbApp do
  begin
  a := sqr(T.TabFamApp[k,1])+sqr(T.TabFamApp[k,3]);
  b := T.TabFamApp[k,1]*T.TabFamApp[k,2]+T.TabFamApp[k,4]*T.TabFamApp[k,3];
  c := sqr(T.TabFamApp[k,2])+sqr(T.TabFamApp[k,4]);
  if (a+c+sqrt(sqr(a-c)+4*sqr(b)) > 2 ) then
    begin
    Contractante := False;
    Break;
    end;
  end;
end;

procedure Heure(var D : Date);
var Present : TDateTime;
    n,i,annee,jour,mois,heure,min,sec,msec : Word;
    tn : Longint;
begin
Present := Now;
DecodeDate(Present,annee,mois,jour);
DecodeTime(Present,heure,min,sec,msec);
D.secondes      := sec;
D.millisecondes := msec;
//t := 86400*jour+3600*heure+60*min+sec+msec/1000;
tn := min+60*heure+1440*jour;
i := 1;
while (i<mois) do
   begin
   case i of
      1 : n := 31;
      2 : begin
          if (annee mod 100 = 0) then
             begin
             if ((annee div 100) mod 4 = 0) then n := 29
                                            else n := 28;
             end
             else
             begin
             if (annee mod 4 = 0) then n := 29
                                  else n := 28;
             end
          end;
      3 : n := 31;
      4 : n := 30;
      5 : n := 31;
      6 : n := 30;
      7 : n := 31;
      8 : n := 31;
      9 : n := 30;
     10 : n := 31;
     11 : n := 30;
     12 : n := 31;
   end;
   //t := t + 86400*n;
   tn := tn + 1440*n;
   i := i +1;
   end;

i := 2000;
while (i<annee) do
   begin
   if (i mod 100 = 0) then
             begin
             if ((i div 100) mod 4 = 0) then n := 1
                                            else n := 0;
             end
             else
             begin
             if (i mod 4 = 0) then n := 1
                                  else n := 0;
             end;
   tn := tn + (365+n) * 1440;
   Inc(i);
   end;

D.minutes := tn;

end;

function CalculDureeEnSeconde(D1,D2 : Date):Double;
var i : longint;
begin
i := D2.minutes-D1.minutes;
CalculDureeEnSeconde := i*60+D2.secondes-D1.secondes
                     +(D2.millisecondes-D1.millisecondes)/1000;
end;

function Evalue(f:fonction; A,C,x0,y0,x:Double):Double;
var j : Integer;
    r,s,Ac : Double;
begin
erreur := False;
Evalue := 0;
case f.typ of
  cte       : Evalue := f.valeur;
  variable  : case f.rang of
                0 : Evalue := A;
                1 : Evalue := C;
                2 : Evalue := x0;
                3 : Evalue := y0;
                4 : Evalue := x;
                end;
  OpUnaire  : begin
              r := Evalue(f.gauche^,A,C,x0,y0,x);
              if erreur then Exit;
              case f.oper1 of
                Fmoins  : Evalue := -r;
                Fplus   : Evalue := r;
                Fabs    : Evalue := abs(r);
                Fint    : Evalue := int(r);
                Ffrac   : Evalue := frac(r);
                Fsqr    : Evalue := sqr(r);
                Fsqrt   : if (r>=0) then Evalue := sqrt(r)
                                    else erreur := True;
                Fexp    : Evalue := exp(r);
                Fln     : if (r>0) then Evalue := ln(r)
                                   else erreur := True;
                Flog    : if (r>0) then Evalue := log10(r)
                                   else erreur := True;
                Fsin    : Evalue := sin(r);
                Fcos    : Evalue := cos(r);
                Ftan    : if (cos(r)<>0) then Evalue := tan(r)
                                         else erreur := True;
                Fsh     : Evalue := (exp(r)-exp(-r))/2;
                Fch     : Evalue := (exp(r)+exp(-r))/2;
                Fth     : Evalue := (exp(2*r)-1)/(exp(2*r)+1);
                Farcsin : if (r=-1)
                            then Evalue := -Pi/2
                            else
                            if (r=1) then Evalue := Pi/2
                              else
                              if (r>-1) and (r<1)
                                 then Evalue := arcsin(r)
                                 else erreur := True;
                Farccos : if (r=-1)
                            then Evalue := Pi
                            else
                            if (r=1) then Evalue := 0
                              else
                              if (r>-1) and (r<1)
                                 then Evalue := arccos(r)
                                 else erreur := True;
                Farctan : Evalue := arctan(r);
                Fargsh  : Evalue := ln(r+sqrt(1+sqr(r)));
                Fargch  : if (r>=1)
                            then Evalue := ln(r+sqrt(sqr(r)-1))
                            else erreur := True;
                Fargth  : if (r>-1) and (r<1)
                            then Evalue := ln((1+r)/(1-r))/2
                            else erreur := True;
                end; {case de opUnaire}
              end;
  OpBinaire : begin
              r := Evalue(f.gauche^,A,C,x0,y0,x);
              if erreur then Exit;
              s := Evalue(f.droite^,A,C,x0,y0,x);
              if erreur then Exit;
              case f.oper2 of
                Fsom : Evalue := r+s;
                Fsou : Evalue := r-s;
                Fmul : Evalue := r*s;
                Fdiv : if (abs(s)>1e-50) then Evalue := r/s
                                         else erreur := True;
                Fpui : begin
                       j := Round(s);
                       if (j=s) then
                         begin
                         j := abs(j);
                         Ac := 1;
                         while (j>0) do
                           begin
                           if odd(j) then Ac := Ac*r;
                           r := sqr(r);
                           j := (j shr 1);
                           end;
                         if (s>0) then Evalue := Ac
                                  else if (r<>0) then Evalue := 1/Ac
                                                 else erreur := True;
                         end
                         else
                         begin
                         if (r>0) then Evalue := exp(s*ln(r))
                                  else erreur := True;
                         end;
                       end;
                end;
              end;
  end;

end; {function Evalue}

function EvalueComplexe(f:fonctionC; z0,z,c:Complexe;a,b : Double):Complexe;
var r,s : Complexe;
    Aux,Aux2,aRe,aIm : Double;
    j : Integer;
begin
EvalueComplexe[1] := 0;
EvalueComplexe[2] := 0;
erreur := False;
case f.typ of
  cte       : begin
              EvalueComplexe := f.valeur;
              end;
  variable  : case f.rang of
                0 : begin
                    EvalueComplexe[1] := a;
                    EvalueComplexe[2] := 0;
                    end;
                1 : EvalueComplexe := c;
                5 : EvalueComplexe := z0;
                6 : EvalueComplexe := z;
                7 : begin
                    EvalueComplexe[1] := b;
                    EvalueComplexe[2] := 0;
                    end;
                end;
  OpUnaire  : begin
              r := EvalueComplexe(f.gauche^,z0,z,c,a,b);
              if erreur then Exit;
              case f.oper1 of
                Fmoins  : begin
                          EvalueComplexe[1] := -r[1];
                          EvalueComplexe[2] := -r[2];
                          end;
                Fplus   : begin
                          EvalueComplexe := r;
                          end;
                Fabs    : begin
                          EvalueComplexe[1] := sqrt(sqr(r[1])+sqr(r[2]));
                          EvalueComplexe[2] := 0;
                          end;
                Fflip   : begin
                          EvalueComplexe[1] := r[2];
                          EvalueComplexe[2] := r[1];
                          end;
                Fconj   : begin
                          EvalueComplexe[1] := r[1];
                          EvalueComplexe[2] := -r[2];
                          end;
                Fint    : begin
                          EvalueComplexe[1] := int(r[1]);
                          EvalueComplexe[2] := int(r[2]);
                          end;
                Ffrac   : begin
                          EvalueComplexe[1] := frac(r[1]);
                          EvalueComplexe[2] := frac(r[2]);
                          end;
                Fsqr    : begin
                          EvalueComplexe[1] := (r[1]-r[2])*(r[1]+r[2]);
                          EvalueComplexe[2] := 2*r[1]*r[2];
                          end;
                Fsqrt   : begin
                          Aux := sqrt((r[1]+sqrt(sqr(r[1])+sqr(r[2])))/2);
                          if (Aux =0) then begin
                                           erreur := True;
                                           Exit;
                                           end;
                          EvalueComplexe[1] := Aux;
                          EvalueComplexe[2] := r[2]/2/Aux; {racine 'positive'}
                          end;
                Fexp    : begin
                          Aux := exp(r[1]);
                          EvalueComplexe[1] := Aux*cos(r[2]);
                          EvalueComplexe[2] := Aux*sin(r[2]);
                          end;
                Fln     : begin
                          Aux := sqrt(sqr(r[1])+sqr(r[2]));
                          if (Aux=0) or (r[1]=0) then begin
                                                      erreur := True;
                                                      Exit;
                                                      end;
                          EvalueComplexe[1] := ln(Aux);
                          if (r[1]>0) then EvalueComplexe[2] := Arctan(r[2]/r[1])
                                      else EvalueComplexe[2] := Arctan(r[2]/r[1])+Pii;
                          end;
                Fsin    : begin
                          Aux := exp(r[2]);
                          EvalueComplexe[1] := sin(r[1])*(Aux+1/Aux)/2;
                          EvalueComplexe[2] := cos(r[1])*(Aux-1/Aux)/2;
                          end;
                Fcos    : begin
                          Aux := exp(r[2]);
                          EvalueComplexe[1] := cos(r[1])*(Aux+1/Aux)/2;
                          EvalueComplexe[2] := sin(r[1])*(Aux-1/Aux)/2;
                          end;
                Ftan    : begin
                          Aux2 := exp(r[2]);
                          Aux := 2*(sqr(cos(r[1]))+sqr((Aux2-1/Aux2)/2));
                          if (Aux <> 0) then
                            begin
                            EvalueComplexe[1] := sin(2*r[1])/Aux;
                            EvalueComplexe[2] := (sqr(Aux2)-1/sqr(Aux2))/2/Aux;
                            end
                            else Exit;
                          end;
                Fsh     : begin
                          Aux := exp(r[1]);
                          EvalueComplexe[1] := (Aux-1/Aux)*cos(r[2])/2;
                          EvalueComplexe[2] := (Aux+1/Aux)*sin(r[2])/2;
                          end;
                Fch     : begin
                          Aux := exp(r[1]);
                          EvalueComplexe[1] := (Aux+1/Aux)*cos(r[2])/2;
                          EvalueComplexe[2] := (Aux-1/Aux)*sin(r[2])/2;
                          end;
                Fth     : begin
                          Aux2 := exp(r[1]);
                          Aux := 2*(sqr(cos(r[2]))+sqr((Aux2-1/Aux2)/2));
                          if (Aux <>0) then
                            begin
                            EvalueComplexe[1] := (sqr(Aux2)-1/sqr(Aux2))/2/Aux;
                            EvalueComplexe[2] := sin(2*r[2])/Aux;
                            end;
                          end;
                end; {case de opUnaire}
              end;
  OpBinaire : begin
              r := EvalueComplexe(f.gauche^,z0,z,c,a,b);
              if erreur then Exit;
              s := EvalueComplexe(f.droite^,z0,z,c,a,b);
              if erreur then Exit;
              case f.oper2 of
                Fsom : begin
                       EvalueComplexe[1] := r[1]+s[1];
                       EvalueComplexe[2] := r[2]+s[2];
                       end;
                Fsou : begin
                       EvalueComplexe[1] := r[1]-s[1];
                       EvalueComplexe[2] := r[2]-s[2];
                       end;
                Fmul : begin
                       EvalueComplexe[1] := r[1]*s[1]-r[2]*s[2];
                       EvalueComplexe[2] := r[1]*s[2]+r[2]*s[1];
                       end;
                Fdiv : begin
                       Aux := sqr(s[1])+sqr(s[2]);
                       if (Aux=0) then begin
                                       erreur := True;
                                       Exit;
                                       end;
                       EvalueComplexe[1] := (r[1]*s[1]+r[2]*s[2])/Aux;
                       EvalueComplexe[2] := (r[2]*s[1]-r[1]*s[2])/Aux;
                       end;
                Fpui : begin
                       j  := Round(s[1]);
                       if (j=s[1]) and (s[2]=0) then
                         begin
                         j := abs(j);
                         aRe := 1;
                         aIm := 0;
                         while (j>0) do
                           begin
                           if odd(j) then
                              begin
                              Aux := aRe*r[1]-aIm*r[2];
                              aIm := aRe*r[2]+aIm*r[1];
                              aRe := Aux;
                              end;
                           Aux  := (r[1]-r[2])*(r[1]+r[2]);
                           r[2] := 2*r[1]*r[2];
                           r[1] := Aux;
                           j := (j shr 1);
                           end;
                         if (s[1]>0) then
                            begin
                            EvalueComplexe[1] := aRe;
                            EvalueComplexe[2] := aIm;
                            end
                            else
                            begin
                            Aux := sqr(aRe)+sqr(aIm);
                            if (Aux>0) then
                              begin
                              EvalueComplexe[1] := aRe/Aux;
                              EvalueComplexe[2] := -aIm/Aux;
                              end
                              else Erreur := True;
                            end;
                         end
                         else
                         begin
                         Aux := sqrt(sqr(r[1])+sqr(r[2]));
                         if (Aux = 0) or (r[1]=0) then begin
                                                       erreur := True;
                                                       Exit;
                                                       end;
                         aRe := ln(Aux);
                         if (r[1] > 0) then aIm := Arctan(r[2]/r[1])
                                       else aIm := Arctan(r[2]/r[1])+Pii;
                         Aux := aRe*s[1]-aIm*s[2];
                         aIm := s[1]*aIm+s[2]*aRe;
                         Aux := exp(Aux);
                         EvalueComplexe[1] := Aux*cos(aIm);
                         EvalueComplexe[2] := Aux*sin(aIm);
                         //if (r>0) then Evalue := exp(s*ln(r));
                         end;
                       end;
                end;
              end;
  end;
end; {function EvalueComplexe}


procedure DetruitFonction(var f:fonction);
begin
with f do
  case typ of
    OpUnaire  : Begin
                DetruitFonction(gauche^);
                dispose(gauche);
                end;
    Opbinaire : Begin
                DetruitFonction(gauche^);
                dispose(gauche);
                DetruitFonction(droite^);
                dispose(droite);
                end;
    end;
end; {function Detruitfonction }

procedure DetruitFonctionC(var f:fonctionC);
begin
with f do
  case typ of
    OpUnaire  : Begin
                DetruitFonctionC(gauche^);
                dispose(gauche);
                end;
    Opbinaire : Begin
                DetruitFonctionC(gauche^);
                dispose(gauche);
                DetruitFonctionC(droite^);
                dispose(droite);
                end;
    end;
end; {function Detruitfonction }

procedure ParametreCourant(ProgrammeCourant : Word;var Sb : TStatusBar);
begin
if (1 <= ProgrammeCourant) and (ProgrammeCourant <= 20) then
   begin
   Sb.Panels.Items[0].Text := 'Mandelbrot  Julia  &  Co';
   FormMandel.Visible      := True;
   FormIFSlinSym.Visible   := False;
   FormAttSym.Visible      := False;
   FormIcone.Visible       := False;
   FormFerguson.Visible    := False;
   FormDeD.Visible         := False;
   FormMarkus.Visible      := False;
   end;

if (ProgrammeCourant = 9) then FormMJGeneral.Visible := True
                          else FormMJGeneral.Visible := False;

if (21 = ProgrammeCourant) then
   begin
   Sb.Panels.Items[0].Text := 'Symmetrical linear IFS';
   FormMandel.Visible    := False;
   FormIFSlinSym.Visible := True;
   FormAttSym.Visible    := False;
   FormIcone.Visible     := False;
   FormFerguson.Visible  := False;
   FormDeD.Visible       := False;
   FormMarkus.Visible    := False;
   end;

if (22 = ProgrammeCourant) then
   begin
   Sb.Panels.Items[0].Text := 'IFS of D(O;1)';
   FormMandel.Visible    := False;
   FormIFSlinSym.Visible := False;
   FormAttSym.Visible    := False;
   FormIcone.Visible     := False;
   FormFerguson.Visible  := False;
   FormDeD.Visible       := True;
   FormMarkus.Visible    := False;
   end;

if (ProgrammeCourant = 41) then
   begin
   Sb.Panels.Items[0].Text := 'IFS of square';
   FormMandel.Visible    := False;
   FormIFSlinSym.Visible := False;
   FormAttSym.Visible    := False;
   FormIcone.Visible     := True;
   FormFerguson.Visible  := False;
   FormDeD.Visible       := False;
   FormMarkus.Visible    := False;
   end;
if (42 <= ProgrammeCourant) and (ProgrammeCourant <= 43) then
   begin
   Sb.Panels.Items[0].Text := 'Non linear symmetrical attractor';
   FormMandel.Visible    := False;
   FormIFSlinSym.Visible := False;
   FormAttSym.Visible    := True;
   FormIcone.Visible     := False;
   FormFerguson.Visible  := False;
   FormDeD.Visible       := False;
   FormMarkus.Visible    := False;
   end;
if (61 <= ProgrammeCourant) and (ProgrammeCourant <= 80) then
   begin
   Sb.Panels.Items[0].Text := 'Basin of Henon, Mira and Gumowsky';
   FormMandel.Visible    := False;
   FormIFSlinSym.Visible := False;
   FormAttSym.Visible    := False;
   FormIcone.Visible     := False;
   FormFerguson.Visible  := True;
   FormDeD.Visible       := False;
   FormMarkus.Visible    := False;
   end;

if (ProgrammeCourant = 64) then FormFergusonGeneral.Visible := True
                           else FormFergusonGeneral.Visible := False;

if (ProgrammeCourant = 62) then FormListOfFuncMG.Visible := True
                           else FormListOfFuncMG.Visible := False;

if (ProgrammeCourant = 61) then FormListHenon.Visible := True
                           else FormListHenon.Visible := False;

if (81 <= ProgrammeCourant) then
   begin
   Sb.Panels.Items[0].Text := 'Attractor of Markus';
   FormMandel.Visible    := False;
   FormIFSlinSym.Visible := False;
   FormAttSym.Visible    := False;
   FormIcone.Visible     := False;
   FormFerguson.Visible  := False;
   FormDeD.Visible       := False;
   FormMarkus.Visible    := True;

   end;
end;

procedure Mandelbrot(var NI : NewImage;Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                     NbIteration : LongInt );
var i, j,indiceMax: Integer;
    k : LongInt;
    cx, cy, x0, y0, yAux, Aux, DilX, DilY : Extended;
begin
indiceMax := High(NI.tE[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;

for i := 0 to indiceMax do
  begin
  yAux := Ysupe-dilY*i;
  cy   := yAux;
  for j := 0 to indiceMax do
    begin
    x0 := Xinfe+dilX*j;
    y0 := yAux;
    cx := x0;
    for k:=1 to NbIteration do
      begin
      if sqr(x0)+sqr(y0) > 25 then break;
      Aux := (x0-y0)*(x0+y0)+cx;
      y0  := 2*x0*y0+cy;
      x0  := Aux;
      end;
    NI.tE[i,j] := k
    end
  end
end;

procedure Julia(var NI : NewImage;Cx,Cy,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                NbIteration : LongInt );
var i, j, indiceMax : Integer;
    k : LongInt;
    x0, y0, yAux, Aux, DilX, DilY : Extended;
begin
indiceMax := High(NI.tE[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;

for i := 0 to indiceMax do
  begin
  yAux := Ysupe-dilY*i;
  for j := 0 to indiceMax do
    begin
    x0 := Xinfe+dilX*j;
    y0 := yAux;
    for k:=1 to NbIteration do
      begin
      if sqr(x0)+sqr(y0) > 25 then break;
      Aux := (x0-y0)*(x0+y0)+Cx;
      y0  := 2*x0*y0+Cy;
      x0  := Aux;
      end;
    NI.tE[i,j] := k
    end;
  end;
end;

procedure JuliaCubique(var NI : NewImage;
                       a,b,Cx,Cy,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                       NbIteration : LongInt );
// f(z) = z^3 + az^2 + bz + c
var i, j,indiceMax : Integer;
    k : LongInt;
    x0, y0, yAux, Aux, DilX, DilY,Ix , Iy : Extended;
begin
indiceMax := High(NI.tE[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;

for i := 0 to indiceMax do
  begin
  yAux := Ysupe-dilY*i;
  for j := 0 to indiceMax do
    begin
    x0 := Xinfe+dilX*j;
    y0 := yAux;
    for k:=1 to NbIteration do
      begin
      if sqr(x0)+sqr(y0) > 25 then break;
      Ix  := a+x0;
      Iy  := y0;
      Aux := x0*Ix-Iy*y0+b;
      Iy  := y0*Ix+x0*Iy;
      Ix  := Aux;
      Aux := x0*Ix-Iy*y0+cx;
      y0  := y0*Ix+x0*Iy+cy;
      x0  := Aux;
      end;
    NI.tE[i,j] := k
    end;
  end;
end;

procedure MandelbrotCubique(var NI : NewImage;
                            a,b,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                            NbIteration : LongInt );
// f(z) = z^3 + az^2 + bz + c  avec c = z0
var i, j, indiceMax : Integer;
    k : LongInt;
    x0, y0, yAux, Aux, DilX, DilY,Ix , Iy,cx,cy : Extended;
begin
indiceMax := High(NI.tE[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;

for i := 0 to indiceMax do
  begin
  yAux := Ysupe-dilY*i;
  cy   := yAux;
  for j := 0 to indiceMax do
    begin
    x0 := Xinfe+dilX*j;
    cx := x0;
    y0 := yAux;
    for k:=1 to NbIteration do
      begin
      if sqr(x0)+sqr(y0) > 25 then break;
      Ix  := a+x0;
      Iy  := y0;
      Aux := x0*Ix-Iy*y0+b;
      Iy  := y0*Ix+x0*Iy;
      Ix  := Aux;
      Aux := x0*Ix-Iy*y0+cx;
      y0  := y0*Ix+x0*Iy+cy;
      x0  := Aux;
      end;
    NI.tE[i,j] := k
    end;
  end;
end;

procedure MandelbrotTriangle(var NI : NewImage;
                            a,b,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                            NbIteration : LongInt );
// f(z) = z^3 + az^2 + bz + c  avec c = z0
var i, j, indiceMax : Integer;
    k : LongInt;
    x0, y0, yAux, Aux, DilX, DilY,cx,cy,sum,sum2,
    lowbound,ac,az2,ff : Extended;
begin
indiceMax := High(NI.tR[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;

for i := 0 to indiceMax do
  begin
  yAux := Ysupe-dilY*i;
  cy   := yAux;
  for j := 0 to indiceMax do
    begin
    x0 := Xinfe+dilX*j;
    cx := x0;
    y0 := yAux;
    ac := sqrt(sqr(cx)+sqr(cy));
    sum  := 0;
    sum2 := 0;

    for k:=1 to NbIteration do
      begin
      if sqr(x0)+sqr(y0) > 25 then break;
      Aux := (x0-y0)*(x0+y0)+cx;
      y0  := 2*x0*y0+cy;
      x0  := Aux;
      sum2 := sum;
      az2 := sqrt(sqr(x0-cx)+sqr(y0-cy));
      lowbound := abs(az2-ac);
      sum := sum +
            Power((sqrt(sqr(x0)+sqr(y0))-lowbound)/(az2+ac-lowbound+1e-15),a)
      end;
    sum := sum / (k+1);
    sum2 := sum2/k;
    ff := (b-ln(abs(ln(sqrt(sqr(x0)+sqr(y0))))))/ln(2);
    NI.tR[i,j] := sum2+(sum-sum2)*(1+ff);
    //NI.tE[i,j] := k
    end;
  end;
end;


procedure ManowarjMandel_2(var NI : NewImage;
                         a,b,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                         NbIteration : LongInt );
// Zn+1 = (Zn)^2 + (a+ib) * Zn-1 + c  avec c = z0
var i, j, indiceMax : Integer;
    k : LongInt;
    x0, y0, yAux, Aux, DilX, DilY,xx0,yy0,tr,cx,cy : Extended;
begin
indiceMax := High(NI.tE[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;

for i := 0 to indiceMax do
  begin
  yAux := Ysupe-dilY*i;
  cy   := yAux;
  for j := 0 to indiceMax do
    begin
    x0  := Xinfe+dilX*j;
    cx  := x0;
    y0  := yAux;
    xx0 :=x0;
    yy0 :=y0;
    for k:=1 to NbIteration do
      begin
      if sqr(x0)+sqr(y0) > 25 then break;
      Aux := (x0-y0)*(x0+y0)+a*xx0-b*yy0+cx;
      tr  := y0;
      xx0 := x0;
      y0  := 2*x0*y0+a*yy0+b*xx0+cy;
      yy0 := tr;
      x0  := Aux
      end;
    NI.tE[i,j] := k
    end;
  end;
end;

procedure ManowarjMandel_3(var NI : NewImage;
                         a,b,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                         NbIteration : LongInt );

// Zn+1 = (Zn)^3 + (a+ib) * Zn-1 + c  avec c = z0
var i, j, indiceMax : Integer;
    k : LongInt;
    x0, y0, yAux, Aux, DilX, DilY,xx0,yy0,tr,cx,cy : Extended;
begin
indiceMax := High(NI.tE[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;

for i := 0 to indiceMax do
  begin
  yAux := Ysupe-dilY*i;
  cy   := yAux;
  for j := 0 to indiceMax do
    begin
    x0  := Xinfe+dilX*j;
    cx  := x0;
    y0  := yAux;
    xx0 :=x0;
    yy0 :=y0;
    for k:=1 to NbIteration do
      begin
      if sqr(x0)+sqr(y0) > 25 then break;
      Aux := x0*(sqr(x0)-3*sqr(y0))+a*(xx0)-b*yy0+cx;
      tr  := y0;
      xx0 := x0;
      y0  := y0*(3*sqr(x0)-sqr(y0))+a*yy0+b*(xx0)+cy;
      yy0 := tr;
      x0  := Aux;
      end;
    NI.tE[i,j] := k
    end;
  end;
end;

procedure ManowarjJulia_2(var NI : NewImage;
                         a,b,Cx,Cy,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                         NbIteration : LongInt );
// Zn+1 = (Zn)^2 + (a+ib) * Zn-1 + c
var i, j, indiceMax : Integer;
    k : LongInt;
    x0, y0, yAux, Aux, DilX, DilY,xx0,yy0,tr : Extended;
begin
indiceMax := High(NI.tE[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;

for i := 0 to indiceMax do
  begin
  yAux := Ysupe-dilY*i;
  for j := 0 to indiceMax do
    begin
    x0  := Xinfe+dilX*j;
    y0  := yAux;
    xx0 :=x0;
    yy0 :=y0;
    for k:=1 to NbIteration do
      begin
      if sqr(x0)+sqr(y0) > 25 then break;
      Aux := (x0-y0)*(x0+y0)+a*xx0-b*yy0+Cx;
      tr  := y0;
      xx0 := x0;
      y0  := 2*x0*y0+a*yy0+b*xx0+Cy;
      yy0 := tr;
      x0  := Aux
      end;
    NI.tE[i,j] := k
    end;
  end;
end;

procedure MJGeneral(var NI : NewImage;Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                     ana : FonctionC;
                     fractal :TypeFractal;
                     suite :TypeSuite;
                     a,b,cx,cy : Extended;
                     NbIteration : LongInt );
var i, j, indiceMax : Integer;
    k : LongInt;
    DilX, DilY,yAux : Extended;
    c,z,z0,zAux : complexe;
begin
indiceMax := High(NI.tE[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;
erreur := False;

if (fractal = FMandelbrot) then
  begin
  if (suite = simple) then
    begin
    z0[1] := 0;
    z0[2] := 0;
    for i := 0 to indiceMax do
      begin
      yAux := Ysupe-dilY*i;
      for j := 0 to indiceMax do
        begin
        c[1] := Xinfe+dilX*j;
        c[2] := yAux;
        z    := c;
        for k:=1 to NbIteration do
          begin
          if (sqr(z[1])+sqr(z[2]) > 25) or erreur then break;
          z := EvalueComplexe(ana,z0,z,c,a,b);
          end;
        NI.tE[i,j] := k;
        end;
      end;
    end
    else
    if (suite = recurrente) then
      begin
      for i := 0 to indiceMax do
        begin
        yAux := Ysupe-dilY*i;
        for j := 0 to indiceMax do
          begin
          z0[1] := 0;
          z0[2] := 0;
          c[1]  := Xinfe+dilX*j;
          c[2]  := yAux;
          z     := c;
          for k:=1 to NbIteration do
            begin
            if (sqr(z[1])+sqr(z[2]) > 25) or erreur then break;
            zAux := EvalueComplexe(ana,z0,z,c,a,b);
            z0 := z;
            z  := zAux;
            end;  {k}
          NI.tE[i,j] := k;
          end; {j}
        end; {i}
      end; {if (suite = recurrente)}
  end {if (fractal = Mandelbrot)}
  else
  if (fractal = FJulia) then
    begin
    c[1] := cx;
    c[2] := cy;
    if (suite = simple) then
      begin
      z0[1] := 0;
      z0[2] := 0;
      for i := 0 to indiceMax do
        begin
        yAux := Ysupe-dilY*i;
        for j := 0 to indiceMax do
          begin
          z[1] := Xinfe+dilX*j;
          z[2] := yAux;
          for k:=1 to NbIteration do
            begin
            if (sqr(z[1])+sqr(z[2]) > 25) or erreur then break;
            z := EvalueComplexe(ana,z0,z,c,a,b);
            end; {k}
          NI.tE[i,j] := k;
          end    {j}
        end    {i}
      end {if (suite = simple)}
      else
      if (suite = recurrente) then
        begin
        for i := 0 to indiceMax do
          begin
          yAux := Ysupe-dilY*i;
          for j := 0 to indiceMax do
            begin
            z0[1] := 0;
            z0[2] := 0;
            z[1] := Xinfe+dilX*j;
            z[2] := yAux;
            for k:=1 to NbIteration do
              begin
              if (sqr(z[1])+sqr(z[2]) > 25) or erreur then break;
              zAux := EvalueComplexe(ana,z0,z,c,a,b);
              z0 := z;
              z  := zAux;
              end; {k}
            NI.tE[i,j] := k
            end; {j}
          end;  {i}
        end; {if (suite = recurrente)}
    end;  {if (fractal = Julia)}
end;

procedure IFSlinSym(var NI : NewImage;var FamApp : FamilleAppli;
                    Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                    DegSym : byte;
                    Diedral : byte;
                    NbIteration : Longint );
// Si Diedral = 0 alors symtrie Zn si Diedral = 1 alors symtrie Dn
var kk,m,IndiceMax,NbAppli,compApp: Integer;
    k,i,j : Longint;
    coefX,coefY : Extended;
    x0,y0,Aux,Suite,Happ : Double;
    cossin : array[0..255,1..2] of Double;
begin
Randomize;
NbAppli := FamApp.NbApp;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

for k:=0 to DegSym-1 do
    begin
    cossin[k,1]:=cos(Pi2*k/DegSym);
    cossin[k,2]:=sin(Pi2*k/DegSym)
    end;

for kk:=1 to 100 do
    begin
    x0 := 2*Random-1;
    y0 := 2*Random-1;
    for k:=1 to 500 do
        begin
        Happ := Random;
        CompApp := 1;
        Suite := FamApp.TabFamApp[Compapp,7];
        While (Happ > Suite) do
              begin
              Inc(CompApp);
              Suite := Suite + FamApp.TabFamApp[Compapp,7];
              end;

        Aux  := FamApp.TabFamApp[Compapp,1]*x0+FamApp.TabFamApp[Compapp,2]*y0+FamApp.TabFamApp[Compapp,5];
        y0  := FamApp.TabFamApp[Compapp,3]*x0+FamApp.TabFamApp[Compapp,4]*y0+FamApp.TabFamApp[Compapp,6];
        m   := Random(DegSym);
        x0  := cossin[m,1]*Aux-cossin[m,2]*y0;
        y0  := cossin[m,2]*Aux+cossin[m,1]*y0;
        if Diedral=1 then if Random(2)=1 then y0 := -y0;
        end;
    for k:=1 to NbIteration do
        begin
        Happ := Random;
        CompApp := 1;
        Suite := FamApp.TabFamApp[Compapp,7];
        While (Happ > Suite) do
              begin
              Inc(CompApp);
              Suite := Suite + FamApp.TabFamApp[Compapp,7];
              end;

        Aux  := FamApp.TabFamApp[Compapp,1]*x0+FamApp.TabFamApp[Compapp,2]*y0+FamApp.TabFamApp[Compapp,5];
        y0  := FamApp.TabFamApp[Compapp,3]*x0+FamApp.TabFamApp[Compapp,4]*y0+FamApp.TabFamApp[Compapp,6];
        m   := Random(DegSym);
        x0  := cossin[m,1]*Aux-cossin[m,2]*y0;
        y0  := cossin[m,2]*Aux+cossin[m,1]*y0;
        if Diedral=1 then if Random(2)=1 then y0 := -y0;
        j   := Round((x0-Xinfe)*coefX);
        i   := Round((Ysupe-y0)*coefY);
        if (j>=0) and (j<=indiceMax) and (i>=0) and (i<=indiceMax)
           then Inc(NI.tE[i,j]);
        end;
    end;
end;


procedure AttracteurSymetrique(var NI : NewImage;Lambda,Alpha,Beta,Gamma,
                               Omega,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                               DegSym : byte;
                               NbIteration : Longint );
var x0,y0,I0,Ix,Iy,Aux : double;
    coefX,coefY : Extended;
    k,kk,i,j : longint;
    l,IndiceMax : integer;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

for kk:=1 to 100 do
  begin
  x0 := (2*Random-1)/10;
  y0 := (2*Random-1)/10;
  for k:=1 to 1000 do
    begin
    I0  := sqr(x0)+sqr(y0);
    Ix  := x0;
    Iy  := y0;
    for l:=3 to DegSym do
      begin
      Aux := Ix*x0-Iy*y0;
      Iy  := Iy*x0+Ix*y0;
      Ix  := Aux;
      end;
    I0  := lambda+alpha*I0+beta*(Ix*x0-Iy*y0);
    Aux := I0*x0 + gamma*Ix - omega*y0;
    y0  := I0*y0 - gamma*Iy + omega*x0;
    x0  := Aux;

    if sqr(x0)+sqr(y0) > 1e5 then Exit;
           {raise EDiverge.Create('La suite tant certainement divergeante, je renonce'+
                  '  calculer son attracteur !!!')}
    end;
  for k:=1 to NbIteration do
    begin
    I0  := sqr(x0)+sqr(y0);
    Ix  := x0;
    Iy  := y0;
    for l:=3 to DegSym do
      begin
      Aux := Ix*x0-Iy*y0;
      Iy  := Iy*x0+Ix*y0;
      Ix  := Aux;
      end;
    I0  := lambda+alpha*I0+beta*(Ix*x0-Iy*y0);
    Aux := I0*x0 + gamma*Ix - omega*y0;
    y0  := I0*y0 - gamma*Iy + omega*x0;
    x0  := Aux;


    j   := Round((x0-Xinfe)*coefX);
    i   := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end;
end;

procedure AttracteurSymetriqueNonPolynomial
                              (var NI : NewImage;Lambda,Alpha,Beta,Gamma,
                               Omega,Delta,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                               DegSym : byte;
                               p : byte;
                               NbIteration : Longint );
var x0,y0,I0,Ix,Iy,Aux,I11,I22,I3,I4,I5 : Double;
    coefX,coefY : Extended;
    k,kk,i,j : longint;
    l,IndiceMax : integer;
begin
Randomize;
indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

for kk:=1 to 100 do
  begin
  x0 := (2*Random-1)/10;
  y0 := (2*Random-1)/10;
  for k:=1 to 1000 do
    begin
    I0  := sqr(x0)+sqr(y0);
    Ix  := x0;
    Iy  := y0;
    for l:=3 to DegSym do
      begin
      Aux := Ix*x0-Iy*y0;
      Iy  := Iy*x0+Ix*y0;
      Ix  := Aux;
      end;
    I11 := Ix;
    I22 := Iy;
    Ix  := Ix*x0-Iy*y0;
    Iy  := Iy*x0+I11*y0;
    I3  := lambda+alpha*I0+beta*Ix;
    Aux := sqrt(sqr(Ix)+sqr(Iy));
    Ix  := Ix/Aux;
    Iy  := Iy/Aux;
    I4  :=1;
    I5  :=1;
    for l:=1 to p do
      begin
      Aux := I4*Ix-I5*Iy;
      I5  := I4*Iy+I5*Ix;
      I4  := Aux;
      end;
    I3  := I3 + delta*I4*sqrt(I0);
    Aux := I3*x0 + gamma*I11 - omega*y0;
    y0  := I3*y0 - gamma*I22 + omega*x0;
    x0  := Aux;

    if sqr(x0)+sqr(y0) > 1e5 then Exit;
           {raise EDiverge.Create('La suite tant certainement divergeante, je renonce'+
                  '  calculer son attracteur !!!')}
    end;
    for k:=1 to NbIteration do
      begin
      I0  := sqr(x0)+sqr(y0);
      Ix  := x0;
      Iy  := y0;
      for l:=3 to DegSym do
        begin
        Aux := Ix*x0-Iy*y0;
        Iy  := Iy*x0+Ix*y0;
        Ix  := Aux;
        end;
      I11 := Ix;
      I22 := Iy;
      Ix  := Ix*x0-Iy*y0;
      Iy  := Iy*x0+I11*y0;
      I3  := lambda+alpha*I0+beta*Ix;
      Aux := sqrt(sqr(Ix)+sqr(Iy));
      Ix  := Ix/Aux;
      Iy  := Iy/Aux;
      I4  :=1;
      I5  :=1;
      for l:=1 to p do
        begin
        Aux := I4*Ix-I5*Iy;
        I5  := I4*Iy+I5*Ix;
        I4  := Aux;
        end;
      I3  := I3 + delta*I4*sqrt(I0);
      Aux := I3*x0 + gamma*I11 - omega*y0;
      y0  := I3*y0 - gamma*I22 + omega*x0;
      x0  := Aux;

      j   := Round((x0-Xinfe)*coefX);
      i   := Round((Ysupe-y0)*coefY);
      if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
        end;
    end;

end;

procedure CalculAttracteurCouetteNonTranslatee
                          (var NI : NewImage;Lambda,Alpha,Beta,Gamma,
                           Omega,Xinfe,Xsupe,Yinfe,Ysupe,m : Extended;
                           NbIteration : Longint);
var x0,y0,s2x,s2y,c2x,c2y,Aux : Double;
    coefX,coefY : Extended;
    k,kk,i,j : longint;
    IndiceMax : integer;
begin
Randomize;
indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

for kk:=1 to 100 do
  begin
  x0 := 2*Random-1;
  y0 := 2*Random-1;

  for k:=0 to 500 do
    begin
    c2x := cos(Pi2*x0);
    c2y := cos(Pi2*y0);
    s2x := sin(Pi2*x0);
    s2y := sin(Pi2*y0);
    Aux := m*x0+Lambda*s2x+Alpha*s2x*c2y+Beta*2*c2x*s2x+Gamma*sin(6*Pi*x0)*(2*sqr(c2y)-1)-Omega*s2y;
    y0  := ParFrac(m*y0+Lambda*s2y+Alpha*s2y*c2x+Beta*2*c2y*s2y+Gamma*sin(6*Pi*y0)*(2*sqr(c2x)-1)-Omega*s2x);
    x0  := ParFrac(Aux);
    end;

  for k:=1 to NbIteration do
    begin
        //Application.ProcessMessages;
    c2x := cos(Pi2*x0);
    c2y := cos(Pi2*y0);
    s2x := sin(Pi2*x0);
    s2y := sin(Pi2*y0);
    Aux := m*x0+Lambda*s2x+Alpha*s2x*c2y+Beta*2*c2x*s2x+Gamma*sin(6*Pi*x0)*(2*sqr(c2y)-1)-Omega*s2y;
    y0  := ParFrac(m*y0+Lambda*s2y+Alpha*s2y*c2x+Beta*2*c2y*s2y+Gamma*sin(6*Pi*y0)*(2*sqr(c2x)-1)-Omega*s2x);
    x0  := ParFrac(Aux);

    j   := Round((x0-Xinfe)*coefX);
    i   := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end;
end;

procedure CalculAttracteurCouetteTranslatee
                          (var NI : NewImage;Lambda,Alpha,Beta,Gamma,
                           Omega,Xinfe,Xsupe,Yinfe,Ysupe,m : Extended;
                           NbIteration : Longint);
var x0,y0,s2x,s2y,c2x,c2y,Aux : Double;
    coefX,coefY : Extended;
   k,kk,i,j : longint;
   IndiceMax : integer;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

for kk:=1 to 100 do
  begin
  x0 := 2*Random-1;
  y0 := 2*Random-1;

  for k:=0 to 500 do
    begin
    c2x := cos(Pi2*x0);
    c2y := cos(Pi2*y0);
    s2x := sin(Pi2*x0);
    s2y := sin(Pi2*y0);
    Aux := m*x0+Lambda*s2x+Alpha*s2x*c2y+Beta*2*c2x*s2x+Gamma*sin(6*Pi*x0)*(2*sqr(c2y)-1)-Omega*s2y;
    y0  := ParFrac(0.5+m*y0+Lambda*s2y+Alpha*s2y*c2x+Beta*2*c2y*s2y+Gamma*sin(6*Pi*y0)*(2*sqr(c2x)-1)-Omega*s2x);
    x0  := ParFrac(Aux);
    end;

  for k:=1 to NbIteration do
    begin
        //Application.ProcessMessages;
    c2x := cos(Pi2*x0);
    c2y := cos(Pi2*y0);
    s2x := sin(Pi2*x0);
    s2y := sin(Pi2*y0);
    Aux := m*x0+Lambda*s2x+Alpha*s2x*c2y+Beta*2*c2x*s2x+Gamma*sin(6*Pi*x0)*(2*sqr(c2y)-1)-Omega*s2y;
    y0  := ParFrac(0.5+m*y0+Lambda*s2y+Alpha*s2y*c2x+Beta*2*c2y*s2y+Gamma*sin(6*Pi*y0)*(2*sqr(c2x)-1)-Omega*s2x);
    x0  := ParFrac(Aux);

    j   := Round((x0-Xinfe)*coefX);
    i   := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end;
end;


procedure HenonList(var NI : NewImage;
                    indexF : Integer;
                    theta,A,B,r0Min,r0Max,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                    NbDepart,NbIteration : Longint);
var x0,y0,cost,sint,W,V : Double;
    coefX,coefY : Extended;
   k,kk,i,j  : longint;
   IndiceMax : integer;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);
cost := cos(theta);
sint := sin(theta);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

for kk:=1 to NbDepart do
  begin
  V  := r0Min + Random * (r0Max-r0Min);
  W  := Random;
  x0 := V * cos(W * Pi2);
  y0 := V * sin(W * Pi2);

  for k:=1 to NbIteration do
    begin
    //if (abs(x0)+abs(y0) > 1000) then Break;
    //if x0 >= 0 then sign := 1 else sign := -1;

    W  := x0;
    case indexF of
      0 : V  := y0 +A*sin(x0+sqr(x0)+B*y0);
      1 : V  := y0 +A*(x0-sqr(x0))/(1+abs(x0)+B*y0);
      end;
    x0 := x0*cost-V*sint;
    y0 := W*sint+V*cost;

    if abs((x0-Xinfe)*coefX) + abs((Ysupe-y0)*coefY) > 1e5 then Break;
    j   := Round((x0-Xinfe)*coefX);
    i   := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end
end;

procedure Atriatix01(var NI : NewImage;theta,
                     A,B,C,r0Min,r0Max,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                     NbDepart,NbIteration : Longint);
var x0,y0,x,w,sign,cost,sint : Double;
    coefX,coefY : Extended;
    k,kk,i,j : longint;
    IndiceMax : integer;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

cost := cos(theta);
sint := sin(theta);

for kk:=1 to NbDepart do
  begin
  x  := r0Min + Random * (r0Max-r0Min);
  w  := Random;
  x0 := x * cos(w * Pi2);
  y0 := x * sin(w * Pi2);

  w  := 0;
  for k:=1 to NbIteration do
    begin
    //if (abs(x0)+abs(y0) > 1e5) then Break;
    // B*y0+A*x0+2*(1-A)*sqr(x0)/(1+sqr(x0))

    x  := x0;
    x0 := B*cost*y0+x*sint+w;
    w  := A*x0+(1-A)*sqr(x0)/(1+sqr(x0));
    y0 := w - cost*x + B*sint*y0 ;

    if abs((x0-Xinfe)*coefX) + abs((Ysupe-y0)*coefY) > 1e5 then Break;
    j := Round((x0-Xinfe)*coefX);
    i := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end;
end;

procedure Atriatix03(var NI : NewImage;theta,
                     A,B,C,r0Min,r0Max,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                     NbDepart,NbIteration : Longint);
var x0,y0,x,w,sign,cost,sint : Double;
    coefX,coefY : Extended;
   k,kk,i,j : longint;
   IndiceMax : integer;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

cost := cos(theta);
sint := sin(theta);

for kk:=1 to NbDepart do
  begin
  w  := r0Min + Random * (r0Max-r0Min);
  x  := Random;
  x0 := w * cos(x * Pi2);
  y0 := w * sin(x * Pi2);

  w  := 0.0;
  for k:=1 to NbIteration do
    begin
    {x0    := B*y0+w;
     w     := A*sin(C*x0)*sin(sqr(y0)+x0);
     y0    := w - x ;}
     //if x0 >= 0 then sign := 1 else sign := -1;
     //A*cos(C*sqr(x0)+sqr(y0)/x)*sin(y0+sqr(x0-x));
     //A*sin(x0-C/y0)*(sqr(x0)+sqr(y0));      must
     //A*(x0-Trunc(x0))*sin(1+C*sqr(y0));
     //A*sin(C*x0)/sin(sqr(y0)+x);
     // A*cos(sqr(y0)*C+x0+1/sqr(x));

    x  := x0;
    x0 := B*cost*y0+x*sint+w;
    w  := A*sin(x0+C/sqr(y0));
    y0 := w - cost*x + B*sint*y0 ;


    if abs((x0-Xinfe)*coefX) + abs((Ysupe-y0)*coefY) > 1e5 then Break;
    j := Round((x0-Xinfe)*coefX);
    i := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end;
end;

procedure AtriatixList(var NI : NewImage;
                         IndexF : Integer;
                         theta,A,B,C,r0Min,r0Max,
                         Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                         NbDepart,NbIteration : Longint);
var x0,y0,x,w,sign,cost,sint : Double;
    coefX,coefY : Extended;
   k,kk,k3,i,j : longint;
   IndiceMax : integer;
   //cossin : array[0..59,1..2] of Double;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

cost := cos(theta);
sint := sin(theta);

for kk:=1 to NbDepart do
  begin
  w  := r0Min + Random * (r0Max-r0Min);
  x  := Random;
  x0 := w * cos(x * Pi2);
  y0 := w * sin(x * Pi2);

  w  := 0.0;

  for k:=1 to NbIteration do
    begin
      //if x0 >= 0 then sign := 1 else sign := -1;
      //A*cos(x0+C*x/sqr(sqr(sqr(x0*y0))));

    x  := x0;
    x0 := (B)*cost*y0+x*sint+w;
    case indexF of
        0 : w := A*x0+(1-A)*sqr(x0)/(1+sqr(x0));
        1 : w := A*cos(C*sqr(x0)+sqr(y0)/x)*sin(y0+sqr(x0-x));
        2 : w := A*sin(x0-C/y0)*(sqr(x0)+sqr(y0));
        3 : w := A*sin(C*x0)/sin(sqr(y0)+x);
        4 : w := A*cos(sqr(y0)*C+x0+1/sqr(x));
        5 : w := A*sin(frac(x0)-C/y0)*(sqr(x0)+frac(sqr(y0)));
        6 : w := A*tan(x0+C*sqr(y0));//+(1-A)*sqr(x0)/(1+sqr(x0));
        7 : w := A*sin(x0)/(1+sin(x0)+C/y0);
        end;
    y0 := w - cost*x + B*sint*y0 ;

    if abs((x0-Xinfe)*coefX) + abs((Ysupe-y0)*coefY) > 1e5 then Break;
    j := Round((x0-Xinfe)*coefX);
    i := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
         then Inc(NI.tE[i,j]);
    end;
  end;
end;

procedure Atriatix03Bis(var NI : NewImage;
                     theta,A,B,C,r0Min,r0Max,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                     NbDepart,NbIteration : Longint);
var x0,y0,x,w,sign,cost,sint : Double;
    coefX,coefY : Extended;
   k,kk,i,j : longint;
   IndiceMax : integer;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

cost := cos(theta);
sint := sin(theta);

for kk:=1 to NbDepart do
  begin
  w  := r0Min + Random * (r0Max-r0Min);
  x  := Random;
  x0 := w * cos(x * Pi2);
  y0 := w * sin(x * Pi2);
  w  := 0.0;

  for k:=1 to NbIteration do
    begin
    x  := x0;
    x0 := (B)*cost*y0+x*sint+w;
    w  := A*cos(sqr(y0)*C+x0+1/sqr(x));
    y0 := A*sin(x0-C/y0)*(sqr(x0)+sqr(y0)) - cost*x + B*sint*y0 ;

    if abs((x0-Xinfe)*coefX) + abs((Ysupe-y0)*coefY) > 1e5 then Break;
    j := Round((x0-Xinfe)*coefX);
    i := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end;
end;

procedure AtriatixGeneral(var NI : NewImage;theta,
                     A,B,C,r0Min,r0Max,Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                     NbDepart,NbIteration : Longint);
var x0,y0,x,w,sign,cost,sint : Double;
    coefX,coefY : Extended;
   k,kk,i,j : longint;
   IndiceMax : integer;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

cost := cos(theta);
sint := sin(theta);

for kk:=1 to NbDepart do
  begin
  w  := r0Min + Random * (r0Max-r0Min);
  x  := Random;
  x0 := w * cos(x * Pi2);
  y0 := w * sin(x * Pi2);

  w  := 0.0;

  for k:=1 to NbIteration do
    begin
   {x0    := B*y0+w;
    w     := A*sin(C*x0)*sin(sqr(y0)+x0);
    y0    := w - x ;}
    //if x0 >= 0 then sign := 1 else sign := -1;
    //A*cos(C*sqr(x0)+sqr(y0)/x)*sin(y0+sqr(x0-x));
    //A*sin(x0-C/y0)*(sqr(x0)+sqr(y0));
    //A*(x0-Trunc(x0))*sin(1+C*sqr(y0));
    //A*sin(C*x0)/sin(sqr(y0)+x);
    x  := x0;
    x0 := (B)*cost*y0+x*sint+w;
    w  := Evalue(f1,A,C,x0,y0,x);
    y0 := w - cost*x + B*sint*y0 ;

    if (abs((x0-Xinfe)*coefX) + abs((Ysupe-y0)*coefY) > 1e5)
            or (erreur) then Break;
    j := Round((x0-Xinfe)*coefX);
    i := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end;
end;

procedure BijUnite(var NI : NewImage;var FAD : FamilleAppliD;
                   Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                   NbIteration : Longint);
var x0,y0,a,b,Ix,Iy,No,Aux,r,idegre : Double;
    coefX,coefY : Extended;
    k,kk,i,j : longint;
    IndiceMax,l,nb,degree : integer;
    symetrie : TypeSymetrie;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

nb       := FAD.NbApp;
degree   := FAD.degre;
idegre   := 1/degree;
symetrie := FAD.typeSym;

for kk:=1 to 100 do
  begin
  r   := Random;
  Aux := Random;
  x0  := r * cos(Pi2*Aux);
  y0  := r * sin(Pi2*Aux);

  for k:=1 to 500 do
    begin
    l   := Random(nb);
    a   := FAD.TabFamAppD[l,1];
    b   := FAD.TabFamAppD[l,2];
    Ix  := 1-a*x0-b*y0;
    Iy  := b*x0-a*y0;
    No  := sqr(Ix)+sqr(Iy);
    Aux := FAD.TabFamAppD[l,3]*((x0-a)*Ix+(y0-b)*Iy)/No;
    y0  := FAD.TabFamAppD[l,3]*((y0-b)*Ix-(x0-a)*Iy)/No;
    x0  := Aux;
    case symetrie of
      none : ;
      OxOy : begin
             x0 := (1-2*Random(2))*x0;
             y0 := (1-2*Random(2))*y0;
             end;
      Zn   : begin
             l := Random(degree);
             Aux := cos(Pi2*l*idegre)*x0+sin(Pi2*l*idegre)*y0;
             y0  := -sin(Pi2*l*idegre)*x0+cos(Pi2*l*idegre)*y0;
             x0  := Aux;
             end;
      Dn   : begin
             l := Random(degree);
             Aux := cos(Pi2*l*idegre)*x0+sin(Pi2*l*idegre)*y0;
             y0  := -sin(Pi2*l*idegre)*x0+cos(Pi2*l*idegre)*y0;
             x0  := Aux;
             y0 := (1-2*Random(2))*y0;
             end;
      end;
    end;

  for k:=1 to NbIteration do
    begin
    l   := Random(nb);
    a   := FAD.TabFamAppD[l,1];
    b   := FAD.TabFamAppD[l,2];
    Ix  := 1-a*x0-b*y0;
    Iy  := b*x0-a*y0;
    No  := sqr(Ix)+sqr(Iy);
    Aux := FAD.TabFamAppD[l,3]*((x0-a)*Ix+(y0-b)*Iy)/No;
    y0  := FAD.TabFamAppD[l,3]*((y0-b)*Ix-(x0-a)*Iy)/No;
    x0  := Aux;

    case symetrie of
      none : ;
      OxOy : begin
             x0 := (1-2*Random(2))*x0;
             y0 := (1-2*Random(2))*y0;
             end;
      Zn   : begin
             l := Random(degree);
             Aux := cos(Pi2*l*idegre)*x0+sin(Pi2*l*idegre)*y0;
             y0  := -sin(Pi2*l*idegre)*x0+cos(Pi2*l*idegre)*y0;
             x0  := Aux;
             end;
      Dn   : begin
             l := Random(degree);
             Aux := cos(Pi2*l*idegre)*x0+sin(Pi2*l*idegre)*y0;
             y0  := -sin(Pi2*l*idegre)*x0+cos(Pi2*l*idegre)*y0;
             x0  := Aux;
             y0 := (1-2*Random(2))*y0;
             end;
      end;

    j   := Round((x0-Xinfe)*coefX);
    i   := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end;
end;

procedure BijUniteEr(var NI : NewImage;var FAD : FamilleAppliD;
                     Xinfe,Xsupe,Yinfe,Ysupe : Extended;
                     NbIteration : Longint);
var x0,y0,a,b,Ix,Iy,No,Aux,r,idegre : Double;
    coefX,coefY : Extended;
    k,kk,i,j : longint;
    IndiceMax,l,nb,degree : integer;
    symetrie : TypeSymetrie;
begin
Randomize;

indiceMax := High(NI.tE[0]);
coefX := indiceMax /(Xsupe-Xinfe);
coefY := indiceMax /(Ysupe-Yinfe);

for i := 0 to indiceMax do
  for j := 0 to indiceMax do NI.tE[i,j] := 0;

nb       := FAD.NbApp;
degree   := FAD.degre;
idegre   := 1/degree;
symetrie := FAD.typeSym;

for kk:=1 to 100 do
  begin
  r   := Random;
  Aux := Random;
  x0  := r * cos(Pi2*Aux);
  y0  := r * sin(Pi2*Aux);

  for k:=1 to 500 do
    begin
    l   := Random(nb);
    a   := FAD.TabFamAppD[l,1];
    b   := FAD.TabFamAppD[l,2];
    Ix  := 1-a*x0-b*y0;
    Iy  := b*x0-a*y0;
    No  := sqr(Ix)+sqr(Iy);
    Aux := FAD.TabFamAppD[l,3]*((x0-a)*Ix+(y0-b)*Iy)/No;
    y0  := FAD.TabFamAppD[l,3]*((y0-b)*Ix-(x0-a)*Iy)/No;
    x0  := Aux;
    case symetrie of
      none : ;
      OxOy : begin
             x0 := (1-2*Random(2))*x0;
             y0 := (1-2*Random(2))*y0;
             end;
      Zn   : begin
             l := Random(degree);
             Aux := cos(Pi2*l*idegre)*x0+sin(Pi2*l*idegre)*y0;
             y0  := -sin(Pi2*l*idegre*x0)+cos(Pi2*l*idegre)*y0;
             x0  := Aux;
             end;
      Dn   : begin
             l := Random(degree);
             Aux := cos(Pi2*l*idegre)*x0+sin(Pi2*l*idegre)*y0;
             y0  := -sin(Pi2*l*idegre*x0)+cos(Pi2*l*idegre)*y0;
             x0  := Aux;
             y0 := (1-2*Random(2))*y0;
             end;
      end;
    end;

  for k:=1 to NbIteration do
    begin
    l   := Random(nb);
    a   := FAD.TabFamAppD[l,1];
    b   := FAD.TabFamAppD[l,2];
    Ix  := 1-a*x0-b*y0;
    Iy  := b*x0-a*y0;
    No  := sqr(Ix)+sqr(Iy);
    Aux := FAD.TabFamAppD[l,3]*((x0-a)*Ix+(y0-b)*Iy)/No;
    y0  := FAD.TabFamAppD[l,3]*((y0-b)*Ix-(x0-a)*Iy)/No;
    x0  := Aux;

    case symetrie of
      none : ;
      OxOy : begin
             x0 := (1-2*Random(2))*x0;
             y0 := (1-2*Random(2))*y0;
             end;
      Zn   : begin
             l := Random(degree);
             Aux := cos(Pi2*l*idegre)*x0+sin(Pi2*l*idegre)*y0;
             y0  := -sin(Pi2*l*idegre*x0)+cos(Pi2*l*idegre)*y0;
             x0  := Aux;
             end;
      Dn   : begin
             l := Random(degree);
             Aux := cos(Pi2*l*idegre)*x0+sin(Pi2*l*idegre)*y0;
             y0  := -sin(Pi2*l*idegre*x0)+cos(Pi2*l*idegre)*y0;
             x0  := Aux;
             y0 := (1-2*Random(2))*y0;
             end;
      end;

    j   := Round((x0-Xinfe)*coefX);
    i   := Round((Ysupe-y0)*coefY);
    if (j>=0) and (j<=IndiceMax) and (i>=0) and (i<=IndiceMax)
           then Inc(NI.tE[i,j]);
    end;
  end;
end;



procedure Markus01(var NI : NewImage;chaine : String;
                   xIni,Xinfe,Xsupe,Yinfe,Ysupe : Double;
                     NbDepart,NbIteration : Integer );
var i, j, k,FinRacine,indiceMax : Integer;
    Aux,x0,RR,R1c,R2c,R2Aux,DilX,DilY : Double;
    Racine : array[0..MaxRacine] of Boolean;
    Klya : Extended;
begin
indiceMax := High(NI.tR[0]);
dilX := (Xsupe-Xinfe)/indiceMax;
dilY := (Ysupe-Yinfe)/indiceMax;

FinRacine := length(chaine);
for k:=0 to FinRacine do
    if chaine[1+k]='1' then Racine[k]:=False else Racine[k]:=True;

for i := 0 to indiceMax do
  begin
  R2aux := ysupe-dilY*i;
  for j := 0 to indiceMax do
    begin
    R1c := Xinfe+dilX*j;
    R2c := R2aux;
    x0  := xIni;
    for k:=1 to NbDepart do
      begin
      if Racine[k mod FinRacine] then RR := R2c else RR := R1c;
      x0 := RR*x0*(1-x0);
      end;
    Klya := 1;
    for k:=1 to NbIteration do
      begin
      Aux := RR*(1-2*x0);
      if (Aux <> 0) then Klya := Klya * Aux;
      if Racine[k mod FinRacine] then RR := R2c else RR := R1c;
      x0  := RR*x0*(1-x0);
      end;

    NI.tR[i,j] := 1.4426950408889634073 * ln(abs(Klya)) / NbIteration ;;
    end;
  end
end;

procedure VerificationPalette(var P : TablePalette);
var x : Double;
begin
P[1].BorneMin := min;
P[NbPalettes].BorneMax := max;
if (PaletteCourante > 1) then
  begin
  x := StrToFloat(FormPalette.EditBorneMin.Text);
  if (abs(x - P[PaletteCourante].BorneMin) > incertitude) then
     begin
     P[PaletteCourante].BorneMin := x;
     P[PaletteCourante-1].BorneMax := x;
     end;
  end;
if (PaletteCourante < NbPalettes) then
  begin
  x := StrToFloat(FormPalette.EditBorneMax.Text);
  if (abs(x - P[PaletteCourante].BorneMax) > incertitude) then
    begin
    P[PaletteCourante].BorneMax := x;
    P[PaletteCourante+1].BorneMin := x;
    end;
  end;
end;

procedure CalculDistribution(var NI : NewImage;
                             var IRep:TImage;
                             MinLocal,MaxLocal:Double);
var EcartR,aR : Double;
    TtRep : array[0..400] of Longint;   {400 = IRep.Width-1}
    i,j,indiceMax : Integer;
    aI,max : Longint;
begin
for j := 0 to 400 do TtRep[j] := 0;

EcartR := MaxLocal - MinLocal;

if EcartR > 0 then
  begin
  if (NI.Format = entier) then
    begin
    indiceMax := High(NI.tE[0]);
    for i := 0 to indiceMax do
      for j := 0 to indiceMax do
        begin
        aI := NI.tE[i,j];
        if (aI>=MinLocal) and (aI<=MaxLocal)
             then Inc(TtRep[Round(((aI-MinLocal)/EcartR)*400)]);
        end;
    end
    else
    begin
    indiceMax := High(NI.tR[0]);
    for i := 0 to indiceMax do
      for j := 0 to indiceMax do
        begin
        aR := NI.tR[i,j];
        if (aR>=MinLocal) and (aR<=MaxLocal)
              then Inc(TtRep[Round(((aR-MinLocal)/EcartR)*400)]);
        end;
    end;
  max := 0;
  for j := 0 to 400 do
    if TtRep[j] > max then max := TtRep[j];

  with IRep do
    begin
    Canvas.Brush.Color := clWhite;
    Canvas.FillRect(Rect(0,0,IRep.Width,IRep.Height));
    Canvas.Pen.Color := clBlack;
    if max <> 0 then
      for j := 0 to 400 do
        begin
        Canvas.MoveTo(j,Height);
        Canvas.LineTo(j,Round(Height*(1-TtRep[j]/max)))
        end
    end;
  end;
end;

procedure CalculeMinMax(var NI : NewImage;var min,max : Double);
var i,j,indiceMax : Integer;
    aI,minE,maxE : Longint;
    aR,minR,maxR : Double;
begin
if (NI.Format = entier) then
  begin
  indiceMax := High(NI.tE[0]);
  minE := NI.tE[0,0];
  maxE := NI.tE[0,0];
  for i := 0 to indiceMax do
    for j := 0 to indiceMax do
      begin
      aI := NI.tE[i,j];
      //k := Min(10,100);
      if aI < minE then minE := aI;
      if aI > maxE then maxE := aI;
      end;
  min := minE;
  max := maxE;
  end
  else
  begin
  indiceMax := High(NI.tR[0]);
  minR := NI.tR[0,0];
  maxR := NI.tR[0,0];
  for i := 0 to indiceMax do
    for j := 0 to indiceMax do
      begin
      aR := NI.tR[i,j];
      if aR < minR then minR := aR;
      if aR > maxR then maxR := aR;
      end;
  min := minR;
  max := maxR
  end
end;

procedure CalculeContraste(var NI : NewImage;
                           var minContrast,maxContrast : Double);
var i,j,IndiceMaxm1,aI,MinI,maxI,aII : Integer;
    minC,maxC,aR,aRR : Double;
begin
if (NI.Format = entier) then
  begin
  indiceMaxm1 := High(NI.tE[0])-1;
  minI := 214748364;
  maxI := -1;
  for i := 1 to indiceMaxm1 do
    for j := 1 to indiceMaxm1 do
      begin
      aI  := NI.tE[i-1,j-1]+2*NI.tE[i-1,j]+NI.tE[i-1,j+1]
            -NI.tE[i+1,j-1]-2*NI.tE[i+1,j]-NI.tE[i+1,j+1];
      aII := NI.tE[i-1,j-1]+2*NI.tE[i,j-1]+NI.tE[i+1,j-1]
             -NI.tE[i-1,j+1]-2*NI.tE[i,j+1]-NI.tE[i+1,j+1];
      aI := abs(aI)+abs(aII);
      if aI < minI then minI := aI;
      if aI > maxI then maxI := aI;
      end;
  minContrast := minI;
  maxContrast := maxI;
  FormEffet.Edit4.Text := IntToStr(minI);
  FormEffet.Edit5.Text := IntToStr(maxI);
  end
  else
  begin
  indiceMaxm1 := High(NI.tR[0])-1;
  minC := 2147483647;
  maxC := 0;
  for i := 1 to indiceMaxm1 do
    for j := 1 to indiceMaxm1 do
      begin
      aR  := NI.tR[i-1,j-1]+2*NI.tR[i-1,j]+NI.tR[i-1,j+1]
            -NI.tR[i+1,j-1]-2*NI.tR[i+1,j]-NI.tR[i+1,j+1];
      aRR := NI.tR[i-1,j-1]+2*NI.tR[i,j-1]+NI.tR[i+1,j-1]
             -NI.tR[i-1,j+1]-2*NI.tR[i,j+1]-NI.tR[i+1,j+1];
      aR := abs(aR)+abs(aRR);
      if aR < minC then minC := aR;
      if aR > maxC then maxC := aR;
      end;
  minContrast := minC;
  maxContrast := maxC;
  end;
end;


procedure CalculRepartition(var NI : NewImage;
                            var IRep:TImage;
                            var minR,maxR : Double);
var min,max : Double;
    j : Integer;
    TtRep : array[0..400] of Longint;   {400 = IRep.Width-1}
begin

for j := 0 to 400 do TtRep[j] := 0;

CalculeMinMax(NI,min,max);

FormRepartition.LabelMin.Caption := FloatToStr(min);
FormRepartition.LabelMax.Caption := FloatToStr(max);
FormRepartition.EditMin.Text := FloatToStr(min);
FormRepartition.EditMax.Text := FloatToStr(max);
CalculDistribution(NI,IRep,min,max);
minR := min;
maxR := max;
end;

procedure DessineImage(var NI : NewImage;
                       var Pale        : TablePalette;
                       NombrePalettes  : Byte;
                       typeDeffet : effet;
                       var Ima:TImage);

var i, j, A, indice,c,reste,TailleMoins2,indiceMax : Longint;
    aux , Esature,aa,bb,cc,z1,z2,z3,cosinus,
    Hue,Saturation,Value,Red,Green,Blue,
    minContrast,maxContrast,aR : Double;
    IndiceCouleur,TVrai,depart,pas,style,
    inverse : array[1..nombreDePalettes] of Longint;
    SatMin,SatMax,Esat : array[1..nombreDePalettes] of Double;
    BelleImage : TBitmap;
begin

BelleImage             := Graphics.TBitmap.Create;
BelleImage.PixelFormat := pf24bit;

if (NI.format = entier) then indiceMax := High(NI.tE[0])
                        else indiceMax := High(NI.tR[0]);

BelleImage.Height := indiceMax+1;
BelleImage.Width  := indiceMax+1;

TailleMoins2 := BelleImage.Height-2;

for c := 1 to NombrePalettes do pas[c] := Pale[c].pas;
for c := 1 to NombrePalettes do style[c] := Pale[c].style;
for c := 1 to NombrePalettes do IndiceCouleur[c] := Pale[c].IndiceMax;
for c := 1 to NombrePalettes do
   TVrai[c] := IndiceCouleur[c] div abs(Pale[c].Pas);
//for c := 1 to NombrePalettes do TVraiPlus1[c] := TVrai[c]+1;
for c := 1 to NombrePalettes do SatMin[c] := Pale[c].SaturationMin;
for c := 1 to NombrePalettes do SatMax[c] := Pale[c].SaturationMax;
for c := 1 to NombrePalettes do depart[c] := Pale[c].depart;
for c := 1 to NombrePalettes do
  if pas[c] <0 then inverse[c] := -1 else inverse[c] := 0;
for c := 1 to NombrePalettes do Esat[c] := SatMax[c] - SatMin[c];
Esature := 0;
for c := 1 to NombrePalettes do Esature := Esature + abs(Esat[c]);

if Esature > 1e-15 then
  begin
  if (typeDeffet = contrast) then CalculeContraste(NI,minContrast,maxContrast);

  if NI.Format = entier then
    begin
    for i := 0 to indiceMax do
      for j := 0 to indiceMax do
        begin
        z1 := NI.tE[i,j];
        c := 1;
        while (z1 > Pale[c].BorneMax) and (c < NombrePalettes)
          do Inc(c);

        A := Round(((z1-SatMin[c])/Esat[c])*TVrai[c]);
        if (0 <= A) and (A<= TVrai[c])
          then indice := modMath(depart[c]+A*pas[c],IndiceCouleur[c]+1)
          else
          case style[c] of
{satur}    0 : if (A < 0)
                  then indice := modMath(depart[c]+inverse[c]*
                                   (TVrai[c]-1)*pas[c],
                                   TVrai[c]+1)
                  else indice := modMath(depart[c]+
                                           (1+inverse[c])*
                                           (TVrai[c]-1)*pas[c],
                                           TVrai[c]+1);
{cycle}     1 : begin
                reste := modMath(A,TVrai[c]);
                if Odd(divMath(A,TVrai[c]))
                  then indice :=
                       modMath(depart[c]+(TVrai[c]-reste)*pas[c],TVrai[c]+1)
                  else indice :=
                       modMath(depart[c]+reste*pas[c],TVrai[c]+1);
                end;
{modulo}    2 : indice :=
                modMath(depart[c]+modMath(A,TVrai[c])*pas[c],TVrai[c]+1);
            end;

        case typeDeffet of
          aucun  : BelleImage.Canvas.Pixels[j,i] :=
                                  RGB(Pale[c].Couleur[indice,1],
                                      Pale[c].Couleur[indice,2],
                                      Pale[c].Couleur[indice,3]);
          relief : begin
                   if (i <=TailleMoins2) and (j <=TailleMoins2)
                     then
                     begin
                     z2  := NI.tE[i,j+1];
                     z3  := NI.tE[i+1,j];
                     aa  := z1-z2;
                     bb  := z1-z3;
                     end
                     else
                     if (j <= TailleMoins2) and (i > TailleMoins2)
                       then
                       begin
                       z2  := NI.tE[i,j+1];
                       z3  := NI.tE[i-1,j];
                       aa  := z3-z1;
                       bb  := z1-z2;
                       end
                       else
                       if (j > TailleMoins2) and (i <= TailleMoins2)
                         then
                         begin
                         z2 := NI.tE[i,j-1];
                         z3 := NI.tE[i+1,j];
                         aa  := z2-z1;
                         bb  := z1-z3;
                         end
                         else
                         begin
                         z2  := NI.tE[i,j-1];
                         z3  := NI.tE[i-1,j];
                         aa  := z3-z1;
                         bb  := z2-z1;
                         end;

                   Aux     := sqrt(sqr(aa)+sqr(bb)+1);
                   aa      := aa/Aux;
                   bb      := bb/Aux;
                   cc      := 1/Aux;
                   cosinus := aa*aEclair+bb*bEclair+cc*cEclair;
                   RGBToHSV(Pale[c].Couleur[indice,1]/255,
                            Pale[c].Couleur[indice,2]/255,
                            Pale[c].Couleur[indice,3]/255,
                            Hue,
                            Saturation,
                            Value);

                   Value := Value + Kintensite * cosinus;
                   if Value > 1 then Value := 1;
                   if Value < 0 then Value := 0;
                   HSVToRGB(Hue,
                            Saturation,
                            Value,
                            Red,
                            Green,
                            Blue);


                   BelleImage.Canvas.Pixels[j,i] :=
                       RGB(Trunc(255*Red),
                           Trunc(255*Green),
                           Trunc(255*Blue));
                   end;
        hollowValue :
                  begin
                  RGBToHSV(Pale[c].Couleur[indice,1]/255,
                           Pale[c].Couleur[indice,2]/255,
                           Pale[c].Couleur[indice,3]/255,
                           Hue,
                           Saturation,
                           Value);

                  Value := Value + Kintensite *
                                     cos((z1-minEffet)*Pii/
                                         (maxEffet-minEffet));
                  if Value > 1 then Value := 1;
                  if Value < 0 then Value := 0;
                  HSVToRGB(Hue,
                           Saturation,
                           Value,
                           Red,
                           Green,
                           Blue);

                  BelleImage.Canvas.Pixels[j,i] :=
                       RGB(Trunc(255*Red),
                           Trunc(255*Green),
                           Trunc(255*Blue));
                  end;
       contrast : begin
                  if (i>=1) and (i+1 <= indiceMax)
                      and (j>=1) and (j+1 <= indiceMax)
                    then
                    begin
                    aR := abs(NI.tE[i-1,j-1]+2*NI.tE[i-1,j]+NI.tE[i-1,j+1]
                          -NI.tE[i+1,j-1]-2*NI.tE[i+1,j]-NI.tE[i+1,j+1])+
                          abs(NI.tE[i-1,j-1]+2*NI.tE[i,j-1]+NI.tE[i+1,j-1]
                          -NI.tE[i-1,j+1]-2*NI.tE[i,j+1]-NI.tE[i+1,j+1]);
                    RGBToHSV(Pale[c].Couleur[indice,1]/255,
                             Pale[c].Couleur[indice,2]/255,
                             Pale[c].Couleur[indice,3]/255,
                             Hue,
                             Saturation,
                             Value);

                    Value := Value + Kintensite *
                             (maxContrast-aR)/(maxContrast-minContrast);
                    if Value > 1 then Value := 1;
                    if Value < 0 then Value := 0;
                    HSVToRGB(Hue,
                             Saturation,
                             Value,
                             Red,
                             Green,
                             Blue);


                    {BelleImage.Canvas.Pixels[j,i] :=
                       RGB(Trunc(255*Red),
                           Trunc(255*Green),
                           Trunc(255*Blue));}
                    Auxi[i,j] := Round(aR);
                    BelleImage.Canvas.Pixels[j,i] :=
                       RGB(Trunc(255*(maxContrast-aR)/(maxContrast-minContrast)),
                           Trunc(255*(maxContrast-aR)/(maxContrast-minContrast)),
                           Trunc(255*(maxContrast-aR)/(maxContrast-minContrast)));
                    end
                  end;
          end;  {case typeDeffet of}
      end; {for j := }
    end
    else
    begin
    for i := 0 to indiceMax do
      for j := 0 to indiceMax do
        begin
        z1 := NI.tR[i,j];
        c  := 1;
        while (z1 > Pale[c].BorneMax) and (c < NombrePalettes)
          do Inc(c);

        A := Round(((z1-SatMin[c])/Esat[c])*TVrai[c]);

        if (0 <= A) and (A<= TVrai[c])
          then indice := modMath(depart[c]+A*pas[c],IndiceCouleur[c]+1)
          else
          case style[c] of
{satur}    0 : if (A < 0)
                  then indice := modMath(depart[c]+inverse[c]*
                                   (TVrai[c]-1)*pas[c],
                                   TVrai[c]+1)
                  else indice := modMath(depart[c]+
                                           (1+inverse[c])*
                                           (TVrai[c]-1)*pas[c],
                                           TVrai[c]+1);
{cycle}     1 : begin
                reste := modMath(A,TVrai[c]);
                if Odd(divMath(A,TVrai[c]))
                  then indice :=
                       modMath(depart[c]+(TVrai[c]-reste)*pas[c],TVrai[c]+1)
                  else indice :=
                       modMath(depart[c]+reste*pas[c],TVrai[c]+1);
                end;
{modulo}    2 : indice :=
                modMath(depart[c]+modMath(A,TVrai[c])*pas[c],TVrai[c]+1);
            end;


        case typeDeffet of
            aucun  : BelleImage.Canvas.Pixels[j,i] :=
                                    RGB(Pale[c].Couleur[indice,1],
                                        Pale[c].Couleur[indice,2],
                                        Pale[c].Couleur[indice,3]);
            relief : begin
                     if (i <=TailleMoins2) and (j <=TailleMoins2)
                       then
                       begin
                       z2  := NI.tR[i,j+1];
                       z3  := NI.tR[i+1,j];
                       aa  := z1-z2;
                       bb  := z1-z3;
                       end
                       else
                       if (j <= TailleMoins2) and (i > TailleMoins2)
                         then
                         begin
                         z2  := NI.tR[i,j+1];
                         z3  := NI.tR[i-1,j];
                         aa  := z3-z1;
                         bb  := z1-z2;
                         end
                         else
                         if (j > TailleMoins2) and (i <= TailleMoins2)
                           then
                           begin
                           z2 := NI.tR[i,j-1];
                           z3 := NI.tR[i+1,j];
                           aa  := z2-z1;
                           bb  := z1-z3;
                           end
                           else
                           begin
                           z2  := NI.tR[i,j-1];
                           z3  := NI.tR[i-1,j];
                           aa  := z3-z1;
                           bb  := z2-z1;
                           end;

                     Aux     := sqrt(sqr(aa)+sqr(bb)+1);
                     aa      := aa/Aux;
                     bb      := bb/Aux;
                     cc      := 1/Aux;
                     cosinus := aa*aEclair+bb*bEclair+cc*cEclair;
                     RGBToHSV(Pale[c].Couleur[indice,1]/255,
                              Pale[c].Couleur[indice,2]/255,
                              Pale[c].Couleur[indice,3]/255,
                              Hue,
                              Saturation,
                              Value);

                     Value := Value + Kintensite * cosinus;
                     if Value > 1 then Value := 1;
                     if Value < 0 then Value := 0;
                     HSVToRGB(Hue,
                              Saturation,
                              Value,
                              Red,
                              Green,
                              Blue);


                     BelleImage.Canvas.Pixels[j,i] :=
                         RGB(Trunc(255*Red),
                             Trunc(255*Green),
                             Trunc(255*Blue));
                     end;
          hollowValue :
                    begin
                    RGBToHSV(Pale[c].Couleur[indice,1]/255,
                             Pale[c].Couleur[indice,2]/255,
                             Pale[c].Couleur[indice,3]/255,
                             Hue,
                             Saturation,
                             Value);

                    Value := Value + Kintensite *
                                       cos((z1-minEffet)*Pii/
                                          (maxEffet-minEffet));
                    if Value > 1 then Value := 1;
                    if Value < 0 then Value := 0;
                    HSVToRGB(Hue,
                             Saturation,
                             Value,
                             Red,
                             Green,
                             Blue);

                    BelleImage.Canvas.Pixels[j,i] :=
                         RGB(Trunc(255*Red),
                             Trunc(255*Green),
                             Trunc(255*Blue));
                    end;
       contrast : begin
                  if (i>=1) and (i+1 <= indiceMax)
                      and (j>=1) and (j+1 <= indiceMax)
                    then
                    begin
                    aR := abs(NI.tR[i-1,j-1]+2*NI.tR[i-1,j]+NI.tR[i-1,j+1]
                          -NI.tR[i+1,j-1]-2*NI.tR[i+1,j]-NI.tR[i+1,j+1])+
                          abs(NI.tR[i-1,j-1]+2*NI.tR[i,j-1]+NI.tR[i+1,j-1]
                          -NI.tR[i-1,j+1]-2*NI.tR[i,j+1]-NI.tR[i+1,j+1]);
                    RGBToHSV(Pale[c].Couleur[indice,1]/255,
                             Pale[c].Couleur[indice,2]/255,
                             Pale[c].Couleur[indice,3]/255,
                             Hue,
                             Saturation,
                             Value);

                    Value := Value + Kintensite *
                             (maxContrast-aR)/(maxContrast-minContrast);
                    if Value > 1 then Value := 1;
                    if Value < 0 then Value := 0;
                    HSVToRGB(Hue,
                             Saturation,
                             Value,
                             Red,
                             Green,
                             Blue);


                    {BelleImage.Canvas.Pixels[j,i] :=
                       RGB(Trunc(255*Red),
                           Trunc(255*Green),
                           Trunc(255*Blue));}
                    BelleImage.Canvas.Pixels[j,i] :=
                       RGB(Trunc(255*(maxContrast-aR)/(maxContrast-minContrast)),
                           Trunc(255*(maxContrast-aR)/(maxContrast-minContrast)),
                           Trunc(255*(maxContrast-aR)/(maxContrast-minContrast)));
                    end
                  end;
          end;  {du case typeDeffet of}

        end;  { for j := }
    end {type rel}
  end  {Esature}
  else
  begin
   // je ne sais pas ce que je fais dans ce cas...
  end;

if (TypeDeffet=contrast) then
  begin
  for i :=1 to indiceMax-1 do
    for j := 1 to indiceMax-1 do
      NI.tE[i,j]:= Trunc(2*(maxContrast-Auxi[i,j])/(maxContrast-minContrast));
  for j:=1 to indiceMax-1 do NI.tE[0,j]:= NI.tE[1,j];
  for j:=1 to indiceMax-1 do NI.tE[indiceMax,j]:= NI.tE[indiceMax-1,j];
  for i:=1 to indiceMax-1 do NI.tE[i,indiceMax]:= NI.tE[i,indiceMax-1];
  for i:=1 to indiceMax-1 do NI.tE[i,0]:= NI.tE[i,1];
  NI.tE[0,0]:= NI.tE[1,1];
  NI.tE[0,indiceMax]:= NI.tE[1,indiceMax-1];
  NI.tE[indiceMax,0]:= NI.tE[indiceMax-1,1];
  NI.tE[indiceMax,indiceMax]:= NI.tE[indiceMax-1,indiceMax-1];
  end;

Ima.Picture.Bitmap.Assign(BelleImage);
BelleImage.Free;
end;


procedure CreeImage(IndiceMaximal : Integer;
                    Format : TypeMatrice;
                    var NI : NewImage);
begin
NI.Format := Format;
if (Format = entier)
   then
   begin
   SetLength(NI.tE,IndiceMaximal,IndiceMaximal);
   SetLength(Auxi,IndiceMaximal,IndiceMaximal);
   finalize(NI.tR);
   NI.tR := nil;
   end
   else
   begin
   SetLength(NI.tR,IndiceMaximal,IndiceMaximal);
   finalize(NI.tE);
   NI.tE := nil;
   end;
end;

procedure DetruitImage(var NI : NewImage);
begin
if (NI.Format = entier)
  then
  begin
  Finalize(NI.tE);
  Finalize(Auxi);
  NI.tE := nil;
  end
  else
  begin
  Finalize(NI.tR);
  NI.tE := nil;
  end;
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
DetruitImage(NewPict);
DetruitFonction(f1);
DetruitFonctionC(fC);
Form1.Canvas.Brush.Bitmap := nil;
Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var k : byte;
begin
// On initialise les paramtres du programme.
Image1.Canvas.Pen.Color := clBlue;
BoutonEnfonce := False;
CadreCree := False;
OverallMovement := False;
cadreModifie := -1;
Image1.Canvas.Pen.Mode := pmNotXor;

CreationArbreC := False;
CreationArbre  := False;
//ObjetCalcule   := True;

lEffet := aucun;
CreeImage(511,entier,NewPict);
TailleCourante := Taille512;

ProgrammeCourant := 1;
NbPalettes       := 1;
PaletteCourante  := 1;
Mandelbrot1.checked := True;
//FormPalette.Visible := True;
N512x5121.checked := True;
StatusBar1.Panels.Items[0].Text := 'Mandelbrot  Julia  &  Co';


coordonneesCourante := 0;
coordonnees[0,1] := -2.5;
coordonnees[0,2] := 1;
coordonnees[0,3] := -1.5;
coordonnees[0,4] := 1.5;

//Palette HSV inverse

TableauPalette[PaletteCourante].Nom :='Rainbow';
TableauPalette[PaletteCourante].IndiceMax := 1785;
TableauPalette[PaletteCourante].Pas := 1;
TableauPalette[PaletteCourante].Style := 0;
TableauPalette[PaletteCourante].Depart := 0;
TableauPalette[PaletteCourante].SaturationMin := 3;
TableauPalette[PaletteCourante].SaturationMax := 75;
TableauPalette[PaletteCourante].BorneMin := 0;
TableauPalette[PaletteCourante].BorneMax := 101;

for k:=0 to 255 do
    begin
    TableauPalette[PaletteCourante].Couleur[k,1]:=255;
    TableauPalette[PaletteCourante].Couleur[k,2]:=255-k;
    TableauPalette[PaletteCourante].Couleur[k,3]:=255;
    end;
for k:=1 to 255 do
    begin
    TableauPalette[PaletteCourante].Couleur[k+255,1]:=255-k;
    TableauPalette[PaletteCourante].Couleur[k+255,2]:=0;
    TableauPalette[PaletteCourante].Couleur[k+255,3]:=255;
    TableauPalette[PaletteCourante].Couleur[k+510,1]:=0;
    TableauPalette[PaletteCourante].Couleur[k+510,2]:=k;
    TableauPalette[PaletteCourante].Couleur[k+510,3]:=255;
    TableauPalette[PaletteCourante].Couleur[k+765,1]:=0;
    TableauPalette[PaletteCourante].Couleur[k+765,2]:=255;
    TableauPalette[PaletteCourante].Couleur[k+765,3]:=255-k;
    TableauPalette[PaletteCourante].Couleur[k+1020,1]:=k;
    TableauPalette[PaletteCourante].Couleur[k+1020,2]:=255;
    TableauPalette[PaletteCourante].Couleur[k+1020,3]:=0;
    TableauPalette[PaletteCourante].Couleur[k+1275,1]:=255;
    TableauPalette[PaletteCourante].Couleur[k+1275,2]:=255-k;
    TableauPalette[PaletteCourante].Couleur[k+1275,3]:=0;
    TableauPalette[PaletteCourante].Couleur[k+1530,1]:=255-k;
    TableauPalette[PaletteCourante].Couleur[k+1530,2]:=0;
    TableauPalette[PaletteCourante].Couleur[k+1530,3]:=0;
    end;

Heure(Dinitiale);

Mandelbrot(NewPict,
           coordonnees[coordonneesCourante,1],
           coordonnees[coordonneesCourante,2],
           coordonnees[coordonneesCourante,3],
           coordonnees[coordonneesCourante,4],
           100);

Heure(Dfinale);
StatusBar1.Panels.Items[1].Text := 'dt = ' +
    FloatToStr(CalculDureeEnSeconde(Dinitiale,Dfinale)) + ' secondes';
//pas := 1;
//depart := 0;
//style := 0;
//satMin := 2;
//satMax := 25;
min := 3;
max := 75;

phi := 45/180*Pii;
theta := 45/180*Pii;
aEclair := cos(theta)*cos(phi);
bEclair := cos(theta)*sin(phi);
cEclair := sin(theta);
Kintensite := 0.1;



DessineImage(NewPict,TableauPalette,NbPalettes,lEffet,Image1);

end;

procedure TForm1.N256x2561Click(Sender: TObject);
var fo : TypeMatrice;
begin
//ObjetCalcule := False;
N256x2561.Checked := True;
Form1.Height := Taille256+80;
Form1.Width  := Taille256+80;

if (tailleCourante <> Taille256) then
   begin
   fo := NewPict.Format;
   DetruitImage(NewPict);
   CreeImage(Taille256,fo,NewPict);
   end;
TailleCourante := Taille256;
end;

procedure TForm1.N512x5121Click(Sender: TObject);
var fo : TypeMatrice;
begin
//ObjetCalcule := False;
N512x5121.Checked := True;
Form1.Height := Taille512+80;
Form1.Width  := Taille512+80;

if (TailleCourante <> Taille512) then
   begin
   fo := NewPict.Format;
   DetruitImage(NewPict);
   CreeImage(Taille512,fo,NewPict);
   end;
TailleCourante := Taille512;
end;

procedure TForm1.N1024x10241Click(Sender: TObject);
var fo : TypeMatrice;
begin
//ObjetCalcule := False;
N1024x10241.Checked := True;
Form1.Height := Taille1024+80;
Form1.Width  := Taille1024+80;

if (TailleCourante <> Taille1024) then
   begin
   fo := NewPict.Format;
   DetruitImage(NewPict);
   CreeImage(Taille1024,fo,NewPict);
   end;
TailleCourante := Taille1024;
end;

procedure TForm1.N2048x20481Click(Sender: TObject);
var fo : TypeMatrice;
begin
//ObjetCalcule := False;
N2048x20481.Checked := True;
Form1.Height := Taille2048+80;
Form1.Width  := Taille2048+80;

if (TailleCourante <> Taille2048) then
   begin
   fo := NewPict.Format;
   DetruitImage(NewPict);
   CreeImage(Taille2048,fo,NewPict);
   end;
TailleCourante := Taille2048;
end;

procedure TForm1.Mandelbrot1Click(Sender: TObject);
begin
//Mandelbrot1.Checked := True;
//ObjetCalcule := False;
FormMandel.Visible := True;
FormCadre.Visible  := True;
FormMandel.Edita.Text := '';
FormMandel.Editb.Text := '';
FormMandel.EditCx.Text := '';
FormMandel.EditCy.Text := '';
ProgrammeCourant := 1;
FormMandel.Panel1.Enabled := False;
FormMandel.Panel2.Enabled := False;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.Julia1Click(Sender: TObject);
begin
//Julia1.Checked := True;
//ObjetCalcule := False;
FormMandel.Visible := True;
FormCadre.Visible  := True;
FormMandel.Edita.Text := '';
FormMandel.Editb.Text := '';
FormMandel.EditCx.Text := '0.38';
FormMandel.EditCy.Text := '0.2277';
ProgrammeCourant := 2;
FormMandel.Panel1.Enabled := True;
FormMandel.Panel2.Enabled := False;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.Mandelbrot21Click(Sender: TObject);
begin
//Mandelbrot21.Checked := True;
//ObjetCalcule := False;
FormMandel.Visible := True;
FormCadre.Visible  := True;
FormMandel.Edita.Text := '-2';
FormMandel.Editb.Text := '0.3';
FormMandel.EditCx.Text := '';
FormMandel.EditCy.Text := '';
ProgrammeCourant := 3;
FormMandel.Panel1.Enabled := False;
FormMandel.Panel2.Enabled := True;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.Julia21Click(Sender: TObject);
begin
//Julia21.Checked := True;
//ObjetCalcule := False;
FormMandel.Visible := True;
FormCadre.Visible  := True;
FormMandel.Edita.Text := '-2';
FormMandel.Editb.Text := '0.3';
FormMandel.EditCx.Text := '0.653';
FormMandel.EditCy.Text := '0.3048';
ProgrammeCourant := 4;
FormMandel.Panel1.Enabled := True;
FormMandel.Panel2.Enabled := True;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.MandelbrotdeK1Click(Sender: TObject);
begin
//MandelbrotdeK1.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
ProgrammeCourant := 5;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <>entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.JuliadeK1Click(Sender: TObject);
begin
//JuliadeK1.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
ProgrammeCourant := 6;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.MandelbrotRec21Click(Sender: TObject);
begin
//MandelbrotRec21.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
FormMandel.Edita.Text := '-0.517';
FormMandel.Editb.Text := '0.7';
FormMandel.EditCx.Text := '';
FormMandel.EditCy.Text := '';
ProgrammeCourant := 7;
ParametreCourant(ProgrammeCourant,StatusBar1);
FormMandel.Panel1.Enabled := False;
FormMandel.Panel2.Enabled := True;
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.JuliaRec21Click(Sender: TObject);
begin
//JuliaRec21.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
FormMandel.Edita.Text := '-0.517';
FormMandel.Editb.Text := '0.7';
FormMandel.EditCx.Text := '-0.11';
FormMandel.EditCy.Text := '-0.72';
ProgrammeCourant := 8;
ParametreCourant(ProgrammeCourant,StatusBar1);
FormMandel.Panel1.Enabled := True;
FormMandel.Panel2.Enabled := True;
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.General1Click(Sender: TObject);
begin
//FormMJGeneral.Visible := True;
//ObjetCalcule := False;
General1.Checked := True;
FormMandel.Edita.Text := '';
FormMandel.Editb.Text := '';
FormMandel.EditCx.Text := '';
FormMandel.EditCy.Text := '';
ProgrammeCourant := 9;
ParametreCourant(ProgrammeCourant,StatusBar1);
FormMandel.Panel1.Enabled := True;
FormMandel.Panel2.Enabled := True;
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.test1Click(Sender: TObject);
begin
FormMandel.Edita.Text := '';
FormMandel.Editb.Text := '';
FormMandel.EditCx.Text := '';
FormMandel.EditCy.Text := '';
ProgrammeCourant := 10;
ParametreCourant(ProgrammeCourant,StatusBar1);
FormMandel.Panel1.Enabled := True;
FormMandel.Panel2.Enabled := True;
if (NewPict.Format <> reel) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,reel,NewPict);
   end
end;

procedure TForm1.Applilin1Click(Sender: TObject);
begin
//Applilin1.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
ProgrammeCourant := 21;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.ApplideD1Click(Sender: TObject);
begin
//ApplideD1.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
ProgrammeCourant := 22;
coordonneesCourante := 0;
coordonnees[coordonneesCourante,1] := -2;
coordonnees[coordonneesCourante,2] := 2;
coordonnees[coordonneesCourante,3] := -2;
coordonnees[coordonneesCourante,4] := 2;
FormCadre.EditXinf.Text := '-2';
FormCadre.EditXsup.Text := '2';
FormCadre.EditYinf.Text := '-2';
FormCadre.EditYsup.Text := '2';
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.Carr1Click(Sender: TObject);
begin
//Carr1.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
ProgrammeCourant := 41;
ParametreCourant(ProgrammeCourant,StatusBar1);
coordonneesCourante := 0;
coordonnees[coordonneesCourante,1] := 0;
coordonnees[coordonneesCourante,2] := 1;
coordonnees[coordonneesCourante,3] := 0;
coordonnees[coordonneesCourante,4] := 1;
FormCadre.EditXinf.Text := '0';
FormCadre.EditXsup.Text := '1';
FormCadre.EditYinf.Text := '0';
FormCadre.EditYsup.Text := '1';
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.Symlin1Click(Sender: TObject);
begin
//Symlin1.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
ProgrammeCourant := 42;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.SymtriqueNonPoly1Click(Sender: TObject);
begin
//SymtriqueNonPoly1.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
ProgrammeCourant := 43;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.Henon1Click(Sender: TObject);
begin
//Henon1.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
coordonneesCourante := 0;
coordonnees[coordonneesCourante,1] := -20;
coordonnees[coordonneesCourante,2] := 20;
coordonnees[coordonneesCourante,3] := -20;
coordonnees[coordonneesCourante,4] := 20;
FormCadre.EditXinf.Text := '-8';
FormCadre.EditXsup.Text := '8';
FormCadre.EditYinf.Text := '-8';
FormCadre.EditYsup.Text := '8';
FormFerguson.Editt.Text := '0.9';
FormFerguson.EditA.Text := '0.05';
FormFerguson.EditB.Text := '-0.03';
FormFerguson.Editr0Max.Text := '12';
FormFerguson.Editr0Min.Text := '0.001';
ProgrammeCourant := 61;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;


procedure TForm1.Ferguson11Click(Sender: TObject);
begin
//Ferguson11.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
coordonneesCourante := 0;
coordonnees[coordonneesCourante,1] := -20;
coordonnees[coordonneesCourante,2] := 20;
coordonnees[coordonneesCourante,3] := -20;
coordonnees[coordonneesCourante,4] := 20;
FormCadre.EditXinf.Text := '-20';
FormCadre.EditXsup.Text := '20';
FormCadre.EditYinf.Text := '-20';
FormCadre.EditYsup.Text := '20';
ProgrammeCourant := 63;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.Ferguson31Click(Sender: TObject);
begin
//Ferguson31.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
coordonneesCourante := 0;
coordonnees[coordonneesCourante,1] := -20;
coordonnees[coordonneesCourante,2] := 20;
coordonnees[coordonneesCourante,3] := -20;
coordonnees[coordonneesCourante,4] := 20;
FormCadre.EditXinf.Text := '-20';
FormCadre.EditXsup.Text := '20';
FormCadre.EditYinf.Text := '-20';
FormCadre.EditYsup.Text := '20';
ProgrammeCourant := 62;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end;
end;

procedure TForm1.FergusonG1Click(Sender: TObject);
begin
//Ferguson31.Checked := True;
//ObjetCalcule := False;
FormCadre.Visible  := True;
coordonneesCourante := 0;
coordonnees[coordonneesCourante,1] := -20;
coordonnees[coordonneesCourante,2] := 20;
coordonnees[coordonneesCourante,3] := -20;
coordonnees[coordonneesCourante,4] := 20;
FormCadre.EditXinf.Text := '-20';
FormCadre.EditXsup.Text := '20';
FormCadre.EditYinf.Text := '-20';
FormCadre.EditYsup.Text := '20';
FormFergusonGeneral.Visible := True;
ProgrammeCourant := 64;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> entier) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,entier,NewPict);
   end
end;

procedure TForm1.logistique1Click(Sender: TObject);
begin
//ObjetCalcule := False;
FormCadre.Visible  := True;
coordonneesCourante := 0;
coordonnees[coordonneesCourante,1] := 0;
coordonnees[coordonneesCourante,2] := 3.999;
coordonnees[coordonneesCourante,3] := 0;
coordonnees[coordonneesCourante,4] := 3.999;
FormCadre.EditXinf.Text := '0';
FormCadre.EditXsup.Text := '3.999';
FormCadre.EditYinf.Text := '0';
FormCadre.EditYsup.Text := '3.999';
ProgrammeCourant := 81;
ParametreCourant(ProgrammeCourant,StatusBar1);
if (NewPict.Format <> reel) then
   begin
   DetruitImage(NewPict);
   CreeImage(TailleCourante,reel,NewPict);
   end
end;

procedure TForm1.Cadre1Click(Sender: TObject);
begin
FormCadre.Visible := True;
end;

procedure Calculate;
var Xinf, Yinf, Xsup, Ysup, Norme2,Norme,Norme1 : Extended;
    t : Byte;
    a,b,cx,cy : Double;
    fractal : TypeFractal;
    suite   : TypeSuite;
begin
//Application.ProcessMessages;
if CadreCree then
  begin
  with Form1.Image1.Canvas do
     begin
     PolyLine([ancPt,
               Point(ancPt.x,nvPt.y),
               nvPt,
               Point(nvPt.x,ancPt.y),
               ancPt]);
     Rectangle(ancPt.x-3,ancPt.y+3,ancPt.x+3,ancPt.y-3);
     Rectangle(ancPt.x-3,nvPt.y+3,ancPt.x+3,nvPt.y-3);
     Rectangle(nvPt.x-3,ancPt.y+3,nvPt.x+3,ancPt.y-3);
     Rectangle(nvPt.x-3,nvPt.y+3,nvPt.x+3,nvPt.y-3);
     end;
  end;

Form1.StatusBar1.Color := clBtnFace;
Form1.StatusBar1.Panels.Items[2].Text := '';
CadreCree := False;
Xinf   := StrToFloat(FormCadre.EditXinf.Text);
Xsup   := StrToFloat(FormCadre.EditXsup.Text);
Yinf   := StrToFloat(FormCadre.EditYinf.Text);
Ysup   := StrToFloat(FormCadre.EditYsup.Text);
Norme  := sqr(Xinf)+sqr(Xsup)+sqr(Yinf)+sqr(Ysup);
Norme1 := sqr(coordonnees[coordonneesCourante,1])+
          sqr(coordonnees[coordonneesCourante,2])+
          sqr(coordonnees[coordonneesCourante,3])+
          sqr(coordonnees[coordonneesCourante,4]);
Norme2 := sqr(Xinf - coordonnees[coordonneesCourante,1])+
          sqr(Xsup - coordonnees[coordonneesCourante,2])+
          sqr(Yinf - coordonnees[coordonneesCourante,3])+
          sqr(Ysup - coordonnees[coordonneesCourante,4]);

if Norme2/(Norme+Norme1) > 1e-28 then
   begin
   if coordonneesCourante = NbZoom then
      begin
      for t := 0 to NbZoom-1 do
       begin
       coordonnees[t,1] := coordonnees[t+1,1];
       coordonnees[t,2] := coordonnees[t+1,2];
       coordonnees[t,3] := coordonnees[t+1,3];
       coordonnees[t,4] := coordonnees[t+1,4];
       end
      end
      else Inc(coordonneesCourante);
   coordonnees[coordonneesCourante,1] := Xinf;
   coordonnees[coordonneesCourante,2] := Xsup;
   coordonnees[coordonneesCourante,3] := Yinf;
   coordonnees[coordonneesCourante,4] := Ysup;
   end;

//Xinf := coordonnees[coordonneesCourante,1];
//Xsup := coordonnees[coordonneesCourante,2];
//Yinf := coordonnees[coordonneesCourante,3];
//Ysup := coordonnees[coordonneesCourante,4];
//Edit1.text := IntToStr(ProgrammeCourant);
//Edit2.Text := IntToStr(coordonneesCourante);
//Cursor := -11;
Heure(Dinitiale);

case ProgrammeCourant of
     1 : Mandelbrot(NewPict,Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormMandel.EditNb.Text));

     2 : Julia(NewPict,StrToFloat(FormMandel.EditCx.Text),
                    StrToFloat(FormMandel.EditCy.Text),
                    Xinf,Xsup,Yinf,Ysup,StrToInt(FormMandel.EditNb.Text));
     3 : MandelbrotCubique(NewPict,
                    StrToFloat(FormMandel.Edita.Text),
                    StrToFloat(FormMandel.Editb.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormMandel.EditNb.Text));
     4 : JuliaCubique(NewPict,
                    StrToFloat(FormMandel.Edita.Text),
                    StrToFloat(FormMandel.Editb.Text),
                    StrToFloat(FormMandel.EditCx.Text),
                    StrToFloat(FormMandel.EditCy.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormMandel.EditNb.Text));
     7 : ManowarjMandel_2(NewPict,
                    StrToFloat(FormMandel.Edita.Text),
                    StrToFloat(FormMandel.Editb.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormMandel.EditNb.Text));
     8 : ManowarjJulia_2(NewPict,
                    StrToFloat(FormMandel.Edita.Text),
                    StrToFloat(FormMandel.Editb.Text),
                    StrToFloat(FormMandel.EditCx.Text),
                    StrToFloat(FormMandel.EditCy.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormMandel.EditNb.Text));
     9 : if CreationArbreC then
           begin
           if FormMandel.Edita.Text <>'' then
             a := StrToFloat(FormMandel.Edita.Text)
             else
             a := 0;
           if FormMandel.Editb.Text <>'' then
             b := StrToFloat(FormMandel.Editb.Text)
             else
             b := 0;
           if FormMandel.EditCx.Text <>'' then
             cx := StrToFloat(FormMandel.EditCx.Text)
             else
             cx := 0;
           if FormMandel.EditCy.Text <>'' then
             cy := StrToFloat(FormMandel.EditCy.Text)
             else
             cy := 0;
           case FormMJGeneral.RadioGroupType.ItemIndex of
             0  : fractal := FMandelbrot;
             1  : fractal := FJulia;
             end;
           case FormMJGeneral.RadioGroupSR.ItemIndex of
             0  : suite := simple;
             1  : suite := recurrente;
             end;
           MJGeneral(NewPict,
                    Xinf,Xsup,Yinf,Ysup,
                    fC,
                    fractal,
                    suite,
                    a,b,cx,cy,
                    StrToInt(FormMandel.EditNb.Text));
           end;
    10 : MandelbrotTriangle(NewPict,
                    StrToFloat(FormMandel.Edita.Text),
                    StrToFloat(FormMandel.Editb.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormMandel.EditNb.Text));
    21 : begin
         FamilleApplication.TabFamApp[FamilleApplicationCourante,1] := StrToFloat(FormIFSlinSym.Edit11.Text);
         FamilleApplication.TabFamApp[FamilleApplicationCourante,2] := StrToFloat(FormIFSlinSym.Edit12.Text);
         FamilleApplication.TabFamApp[FamilleApplicationCourante,3] := StrToFloat(FormIFSlinSym.Edit21.Text);
         FamilleApplication.TabFamApp[FamilleApplicationCourante,4] := StrToFloat(FormIFSlinSym.Edit22.Text);
         FamilleApplication.TabFamApp[FamilleApplicationCourante,5] := StrToFloat(FormIFSlinSym.Editb1.Text);
         FamilleApplication.TabFamApp[FamilleApplicationCourante,6] := StrToFloat(FormIFSlinSym.Editb2.Text);
         FamilleApplication.TabFamApp[FamilleApplicationCourante,7] := StrToFloat(FormIFSlinSym.EditProba.Text);
         if Contractante(FamilleApplication)
           then
             IFSlinSym(NewPict,
                    FamilleApplication,
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormIFSlinSym.Editsym.Text),
                    FormIFSlinSym.RadioGroup1.ItemIndex,
                    StrToInt(FormIFSlinSym.EditNb.Text))
           else
           begin
           Form1.StatusBar1.Color := clRed;
           Form1.StatusBar1.Panels.Items[2].Text := 'Non contractantes';
           end;
         end;
    22 : BijUnite(NewPict,FamilleD,
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormDeD.EditNb.Text));
    41 : begin
         if FormIcone.CheckBox1.Checked = True then
            CalculAttracteurCouetteTranslatee
                          (NewPict,
                    StrToFloat(FormIcone.EditLambda.Text),
                    StrToFloat(FormIcone.EditAlpha.Text),
                    StrToFloat(FormIcone.EditBeta.Text),
                    StrToFloat(FormIcone.EditGamma.Text),
                    StrToFloat(FormIcone.EditOmega.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToFloat(FormIcone.Editm.Text),
                    StrToInt(FormIcone.EditNb.Text))
                                               else
            CalculAttracteurCouetteNonTranslatee
                          (NewPict,
                    StrToFloat(FormIcone.EditLambda.Text),
                    StrToFloat(FormIcone.EditAlpha.Text),
                    StrToFloat(FormIcone.EditBeta.Text),
                    StrToFloat(FormIcone.EditGamma.Text),
                    StrToFloat(FormIcone.EditOmega.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToFloat(FormIcone.Editm.Text),
                    StrToInt(FormIcone.EditNb.Text));

         end;
    42 : AttracteurSymetrique(NewPict,
                    StrToFloat(FormAttSym.EditLambda.Text),
                    StrToFloat(FormAttSym.EditAlpha.Text),
                    StrToFloat(FormAttSym.EditBeta.Text),
                    StrToFloat(FormAttSym.EditGamma.Text),
                    StrToFloat(FormAttSym.EditOmega.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormAttSym.EditDegSym.Text),
                    StrToInt(FormAttSym.EditNb.Text));
    43 : AttracteurSymetriqueNonPolynomial(NewPict,
                    StrToFloat(FormAttSym.EditLambda.Text),
                    StrToFloat(FormAttSym.EditAlpha.Text),
                    StrToFloat(FormAttSym.EditBeta.Text),
                    StrToFloat(FormAttSym.EditGamma.Text),
                    StrToFloat(FormAttSym.EditOmega.Text),
                    StrToFloat(FormAttSym.EditDelta.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormAttSym.EditDegSym.Text),
                    StrToInt(FormAttSym.Editp.Text),
                    StrToInt(FormAttSym.EditNb.Text));
    61 : HenonList(NewPict,
                    FormListHenon.ComboBox1.ItemIndex,
                    StrToFloat(FormFerguson.Editt.Text),
                    StrToFloat(FormFerguson.EditA.Text),
                    StrToFloat(FormFerguson.EditB.Text),
                    StrToFloat(FormFerguson.Editr0Min.Text),
                    StrToFloat(FormFerguson.Editr0Max.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormFerguson.EditNbDepart.Text),
                    StrToInt(FormFerguson.EditNb.Text));
    62 : AtriatixList(NewPict,
                    FormListOfFuncMG.ComboBoxFunc.ItemIndex,
                    StrToFloat(FormFerguson.Editt.Text),
                    StrToFloat(FormFerguson.EditA.Text),
                    StrToFloat(FormFerguson.EditB.Text),
                    StrToFloat(FormFerguson.EditC.Text),
                    StrToFloat(FormFerguson.Editr0Min.Text),
                    StrToFloat(FormFerguson.Editr0Max.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormFerguson.EditNbDepart.Text),
                    StrToInt(FormFerguson.EditNb.Text));
    63 : Atriatix03(NewPict,
                    StrToFloat(FormFerguson.Editt.Text),
                    StrToFloat(FormFerguson.EditA.Text),
                    StrToFloat(FormFerguson.EditB.Text),
                    StrToFloat(FormFerguson.EditC.Text),
                    StrToFloat(FormFerguson.Editr0Min.Text),
                    StrToFloat(FormFerguson.Editr0Max.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormFerguson.EditNbDepart.Text),
                    StrToInt(FormFerguson.EditNb.Text));
    64 : if CreationArbre then AtriatixGeneral(NewPict,
                    StrToFloat(FormFerguson.Editt.Text),
                    StrToFloat(FormFerguson.EditA.Text),
                    StrToFloat(FormFerguson.EditB.Text),
                    StrToFloat(FormFerguson.EditC.Text),
                    StrToFloat(FormFerguson.Editr0Min.Text),
                    StrToFloat(FormFerguson.Editr0Max.Text),
                    Xinf,Xsup,Yinf,Ysup,
                    StrToInt(FormFerguson.EditNbDepart.Text),
                    StrToInt(FormFerguson.EditNb.Text));
    81 : Markus01(NewPict,
                  FormMarkus.EditRacine.Text,
                  StrToFloat(FormMarkus.Editx0.Text),
                  Xinf,Xsup,Yinf,Ysup,
                  StrToInt(FormMarkus.EditNbDepart.Text),
                  StrToInt(FormMarkus.EditNb.Text));
     end;

Heure(Dfinale);
Form1.StatusBar1.Panels.Items[1].Text := 'dt = ' +
    FloatToStr(CalculDureeEnSeconde(Dinitiale,Dfinale)) + ' secondes';

CalculRepartition(NewPict,FormRepartition.ImageRep,min,max);

VerificationPalette(TableauPalette);

//Edit1.Text := FloatToStr(TableauPalette[PaletteCourante].BorneMin);
              //FloatToStr(min);
//Edit2.Text := FloatToStr(max);

FormPalette.EditBorneMin.Text :=
     FloatToStr(TableauPalette[PaletteCourante].BorneMin);
FormPalette.EditBorneMax.Text :=
     FloatToStr(TableauPalette[PaletteCourante].BorneMax);

//FormPalette.EditSatMin.Text := FormRepartition.EditMin.Text;
//FormPalette.EditSatMax.Text := FormRepartition.EditMax.Text;
TableauPalette[PaletteCourante].pas := StrToInt(FormPalette.EditPas.Text);
TableauPalette[PaletteCourante].style := FormPalette.ComboBoxStyle.ItemIndex;
TableauPalette[PaletteCourante].depart :=
  Round(FormPalette.ScrollBar1.Position/100*
        TableauPalette[PaletteCourante].IndiceMax);

TableauPalette[PaletteCourante].SaturationMin   := StrToFloat(FormPalette.EditSatMin.Text);
TableauPalette[PaletteCourante].SaturationMax   := StrToFloat(FormPalette.EditSatMax.Text);


DessineImage(NewPict,TableauPalette,NbPalettes,lEffet,Form1.Image1);

//ObjetCalcule := True;
end;



procedure TForm1.ImageMClick(Sender: TObject);
begin
//if not(ObjetCalcule) then
  //begin
  Calculate;
  ParametreCourant(ProgrammeCourant,StatusBar1);
  FormCadre.Visible := True;
  //end;
end;

procedure TForm1.Repartition1Click(Sender: TObject);
var min,max : Double;
begin
FormRepartition.Visible := True;
CalculRepartition(NewPict,FormRepartition.ImageRep,min,max);
end;



procedure TForm1.Palette1Click(Sender: TObject);
begin
FormPalette.Visible := True;
end;

procedure TForm1.Couleur1Click(Sender: TObject);
begin
if not(CadreCree) then
  begin
  VerificationPalette(TableauPalette);
  TableauPalette[PaletteCourante].pas := StrToInt(FormPalette.EditPas.Text);
  TableauPalette[PaletteCourante].style := FormPalette.ComboBoxStyle.ItemIndex;
  TableauPalette[PaletteCourante].depart :=
      Round(FormPalette.ScrollBar1.Position/100*TableauPalette[PaletteCourante].IndiceMax);
  TableauPalette[PaletteCourante].SaturationMin   := StrToFloat(FormPalette.EditSatMin.Text);
  TableauPalette[PaletteCourante].SaturationMax   := StrToFloat(FormPalette.EditSatMax.Text);

  case lEffet of
    aucun  : ;
    relief : begin
             phi := StrToFloat(FormEffet.Edit1.Text)/180*Pii;
             theta := StrToFloat(FormEffet.Edit2.Text)/180*Pii;
             aEclair := cos(theta)*cos(phi);
             bEclair := cos(theta)*sin(phi);
             cEclair := sin(theta);
             Kintensite := StrToFloat(FormEffet.Edit3.Text);
             end;
    hollowValue :
             begin
             minEffet := StrToFloat(FormEffet.Edit4.Text);
             maxEffet := StrToFloat(FormEffet.Edit5.Text);
             Kintensite := StrToFloat(FormEffet.Edit6.Text);
             end;
    contrast :
             begin
             Kintensite := StrToFloat(FormEffet.Edit3.Text);
             end;
    end;

  DessineImage(NewPict,TableauPalette,NbPalettes,lEffet,Image1);
  end;
FormPalette.Visible := True;
end;

procedure TForm1.Paramtres1Click(Sender: TObject);
begin
ParametreCourant(ProgrammeCourant,StatusBar1)
end;

procedure TForm1.Sauver1Click(Sender: TObject);
begin
if SavePictureDialog1.Execute then
   begin
   //BelleImage.SaveToFile(SavePictureDialog1.FileName+'.bmp');
   Image1.Picture.SaveToFile(SavePictureDialog1.FileName+'.BMP');
   //Form1.Picture.SaveToFile(SavePictureDialog1.FileName+'f'+'.BMP');
   end;
end;


procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var XXinf,XXsup,YYinf,YYsup : Integer;
begin

if (ancPt.x < nvPt.x) then
    begin
    XXinf := ancPt.x;
    XXsup := nvPt.x;
    end
    else
    begin
    XXinf := nvPt.x;
    XXsup := ancPt.x;
    end;
if (ancPt.y < nvPt.y) then
    begin
    YYinf := ancPt.y;
    YYsup := nvPt.y;
    end
    else
    begin
    YYinf := nvPt.y;
    YYsup := ancPt.y;
    end;
if (XXinf <= X) and (X <= XXsup) and (YYinf <= Y) and (Y <= YYsup)
     then  OverallMovement := True
     else  OverallMovement := False;



if (Button=mbLeft) and not(CadreCree) then ancPt := Point(X,Y);
if (X>=ancPt.x-3) and (X<=ancPt.x+3) and (Y>=ancPt.y-3) and (Y<=ancPt.y+3) then
    CadreModifie := 1;
if (X>=nvPt.x-3) and (X<=nvPt.x+3) and (Y>=ancPt.y-3) and (Y<=ancPt.y+3) then
    CadreModifie := 2;
if (X>=nvPt.x-3) and (X<=nvPt.x+3) and (Y>=nvPt.y-3) and (Y<=nvPt.y+3) then
    CadreModifie := 3;
if (X>=ancPt.x-3) and (X<=ancPt.x+3) and (Y>=nvPt.y-3) and (Y<=nvPt.y+3) then
    CadreModifie := 4;

if CadreModifie > -1 then OverallMovement := False;
PointMouvant := Point(X,Y);
BoutonEnfonce := True;
boutonsouris := Button;

end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (Button=mbLeft) and not(CadreCree) and
   ((X <= ancPt.x-2) or (X >= ancPt.x+2) or (Y <= ancPt.y-2) or (Y >= ancPt.y+2))
   then
  begin
  {if abs(X-ancPt.x)+abs(Y-ancPt.y) < 40 then
    begin
    nvPt.x := ancPt.x+30;
    nvPt.y := ancPt.y+30;
    end
    else nvPt := Point(X,Y);}
  nvPt := Point(X,Y);
  CadreCree := True;
  //ObjetCalcule := False;
  end;
BoutonEnfonce := False;
CadreModifie := -1;
//boutonSouris := Button;
end;

procedure TForm1.RetourZoom1Click(Sender: TObject);
begin
if coordonneesCourante > 0 then
   begin
   coordonneesCourante := coordonneesCourante - 1 ;
   FormCadre.EditXinf.Text := FloatToStr(coordonnees[coordonneesCourante,1]);
   FormCadre.EditXsup.Text := FloatToStr(coordonnees[coordonneesCourante,2]);
   FormCadre.EditYinf.Text := FloatToStr(coordonnees[coordonneesCourante,3]);
   FormCadre.EditYsup.Text := FloatToStr(coordonnees[coordonneesCourante,4]);
   //ObjetCalcule := False;
   end;
if CadreCree then
  begin
  with Form1.Image1.Canvas do
     begin
     PolyLine([ancPt,
               Point(ancPt.x,nvPt.y),
               nvPt,
               Point(nvPt.x,ancPt.y),
               ancPt]);
     Rectangle(ancPt.x-3,ancPt.y+3,ancPt.x+3,ancPt.y-3);
     Rectangle(ancPt.x-3,nvPt.y+3,ancPt.x+3,nvPt.y-3);
     Rectangle(nvPt.x-3,ancPt.y+3,nvPt.x+3,ancPt.y-3);
     Rectangle(nvPt.x-3,nvPt.y+3,nvPt.x+3,nvPt.y-3);
     end;
  end;
CadreCree := False;
//Edit2.Text := IntToStr(coordonneesCourante);
end;

procedure TForm1.Distribution1Click(Sender: TObject);
begin
FormRepartition.Visible := True;
CalculDistribution(NewPict,FormRepartition.ImageRep,
                   StrToFloat(FormRepartition.EditMin.Text),
                   StrToFloat(FormRepartition.EditMax.Text))
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var ax,ay,t,XXinf,XXsup,YYinf,YYsup : Integer;
    aux,Xc,Yc,Xd,Yd : Extended;
begin
//t  := (Round(exp(NewPict.IndiceMax*ln(2))))*256-1;
t := tailleCourante;


if not(BoutonEnfonce) then
 begin
 if CadreCree then
  begin
  if (ancPt.x < nvPt.x) then
    begin
    XXinf := ancPt.x;
    XXsup := nvPt.x;
    end
    else
    begin
    XXinf := nvPt.x;
    XXsup := ancPt.x;
    end;
  if (ancPt.y < nvPt.y) then
    begin
    YYinf := ancPt.y;
    YYsup := nvPt.y;
    end
    else
    begin
    YYinf := nvPt.y;
    YYsup := ancPt.y;
    end;
  if (XXinf <= X) and (X <= XXsup) and (YYinf <= Y) and (Y <= YYsup)
     then Image1.Cursor := crSizeAll
     else Image1.Cursor := crCross;
  if (X>=ancPt.x-3) and (X<=ancPt.x+3) and (Y>=ancPt.y-3) and (Y<=ancPt.y+3) then
    Image1.Cursor := crArrow;
  if (X>=nvPt.x-3) and (X<=nvPt.x+3) and (Y>=ancPt.y-3) and (Y<=ancPt.y+3) then
    Image1.Cursor := crArrow;
  if (X>=nvPt.x-3) and (X<=nvPt.x+3) and (Y>=nvPt.y-3) and (Y<=nvPt.y+3) then
    Image1.Cursor := crArrow;
  if (X>=ancPt.x-3) and (X<=ancPt.x+3) and (Y>=nvPt.y-3) and (Y<=nvPt.y+3) then
    Image1.Cursor := crArrow;
  end
  else Image1.Cursor := crCross;
 end;

if BoutonEnfonce and (BoutonSouris=mbLeft) and not(CadreCree) then
  begin
  with Image1.Canvas do
     begin
     PolyLine([ancPt,
               Point(ancPt.x,PointMouvant.y),
               PointMouvant,
               Point(PointMouvant.x,ancPt.y),
               ancPt]);
     Rectangle(ancPt.x-3,ancPt.y+3,ancPt.x+3,ancPt.y-3);
     Rectangle(ancPt.x-3,PointMouvant.y+3,ancPt.x+3,PointMouvant.y-3);
     Rectangle(PointMouvant.x-3,ancPt.y+3,PointMouvant.x+3,ancPt.y-3);
     Rectangle(PointMouvant.x-3,PointMouvant.y+3,PointMouvant.x+3,PointMouvant.y-3);
     PointMouvant := Point(X,Y);

     PolyLine([ancPt,
               Point(ancPt.x,Y),
               PointMouvant,
               Point(X,ancPt.y),
               ancPt]);
     Rectangle(ancPt.x-3,ancPt.y+3,ancPt.x+3,ancPt.y-3);
     Rectangle(ancPt.x-3,Y+3,ancPt.x+3,Y-3);
     Rectangle(X-3,ancPt.y+3,X+3,ancPt.y-3);
     Rectangle(X-3,Y+3,X+3,Y-3);
     end;
  Xc := coordonnees[coordonneesCourante,1]+ancPt.x/t*
      (coordonnees[coordonneesCourante,2]-coordonnees[coordonneesCourante,1]);
  Yc := coordonnees[coordonneesCourante,4]-ancPt.y/t*
      (coordonnees[coordonneesCourante,4]-coordonnees[coordonneesCourante,3]);
  Xd := coordonnees[coordonneesCourante,1]+X/t*
      (coordonnees[coordonneesCourante,2]-coordonnees[coordonneesCourante,1]);
  Yd := coordonnees[coordonneesCourante,4]-Y/t*
      (coordonnees[coordonneesCourante,4]-coordonnees[coordonneesCourante,3]);

  if Xc > Xd then
      begin
      Aux := Xc;
      Xc  := Xd;
      Xd  := Aux
      end;

  if Yc > Yd then
      begin
      Aux := Yc;
      Yc  := Yd;
      Yd  := Aux
      end;
  FormCadre.EditXinf.Text := FloatToStr(Xc);
  FormCadre.EditXsup.Text := FloatToStr(Xd);
  FormCadre.EditYinf.Text := FloatToStr(Yc);
  FormCadre.EditYsup.Text := FloatToStr(Yd);
  end;

if BoutonEnfonce and (BoutonSouris=mbLeft) and
   OverallMovement and CadreCree then
  begin
  with Image1.Canvas do
     begin
     PolyLine([ancPt,
               Point(ancPt.x,nvPt.y),
               nvPt,
               Point(nvPt.x,ancPt.y),
               ancPt]);
     Rectangle(ancPt.x-3,ancPt.y+3,ancPt.x+3,ancPt.y-3);
     Rectangle(ancPt.x-3,nvPt.y+3,ancPt.x+3,nvPt.y-3);
     Rectangle(nvPt.x-3,ancPt.y+3,nvPt.x+3,ancPt.y-3);
     Rectangle(nvPt.x-3,nvPt.y+3,nvPt.x+3,nvPt.y-3);

     ax := X-PointMouvant.x;
     ay := Y-PointMouvant.y;
     PointMouvant := Point(X,Y);
     ancPt := Point(ancPt.x+ax,ancPt.y+ay);
     nvPt  := Point(nvPt.x+ax,nvPt.y+ay);
     PolyLine([ancPt,
               Point(ancPt.x,nvPt.y),
               nvPt,
               Point(nvPt.x,ancPt.y),
               ancPt]);
     Rectangle(ancPt.x-3,ancPt.y+3,ancPt.x+3,ancPt.y-3);
     Rectangle(ancPt.x-3,nvPt.y+3,ancPt.x+3,nvPt.y-3);
     Rectangle(nvPt.x-3,ancPt.y+3,nvPt.x+3,ancPt.y-3);
     Rectangle(nvPt.x-3,nvPt.y+3,nvPt.x+3,nvPt.y-3)
     end;
  Xc := coordonnees[coordonneesCourante,1]+ancPt.x/t*
      (coordonnees[coordonneesCourante,2]-coordonnees[coordonneesCourante,1]);
  Yc := coordonnees[coordonneesCourante,4]-ancPt.y/t*
      (coordonnees[coordonneesCourante,4]-coordonnees[coordonneesCourante,3]);
  Xd := coordonnees[coordonneesCourante,1]+nvPt.x/t*
      (coordonnees[coordonneesCourante,2]-coordonnees[coordonneesCourante,1]);
  Yd := coordonnees[coordonneesCourante,4]-nvPt.y/t*
      (coordonnees[coordonneesCourante,4]-coordonnees[coordonneesCourante,3]);

  if Xc > Xd then
      begin
      Aux := Xc;
      Xc  := Xd;
      Xd  := Aux
      end;

  if Yc > Yd then
      begin
      Aux := Yc;
      Yc  := Yd;
      Yd  := Aux
      end;
  FormCadre.EditXinf.Text := FloatToStr(Xc);
  FormCadre.EditXsup.Text := FloatToStr(Xd);
  FormCadre.EditYinf.Text := FloatToStr(Yc);
  FormCadre.EditYsup.Text := FloatToStr(Yd);
  end;

if BoutonEnfonce and (BoutonSouris=mbLeft) and
   CadreCree and (cadreModifie > -1) then
  begin

  with Image1.Canvas do
     begin
     PolyLine([ancPt,
               Point(ancPt.x,nvPt.y),
               nvPt,
               Point(nvPt.x,ancPt.y),
               ancPt]);
     Rectangle(ancPt.x-3,ancPt.y+3,ancPt.x+3,ancPt.y-3);
     Rectangle(ancPt.x-3,nvPt.y+3,ancPt.x+3,nvPt.y-3);
     Rectangle(nvPt.x-3,ancPt.y+3,nvPt.x+3,ancPt.y-3);
     Rectangle(nvPt.x-3,nvPt.y+3,nvPt.x+3,nvPt.y-3);
     PointMouvant := Point(X,Y);
     case CadreModifie of
       1 : ancPt := Point(X,Y);
       2 : begin
           nvPt.x := X;
           ancPt.y := Y;
           end;
       3 : nvPt := Point(X,Y);
       4 : begin
           ancPt.x := X;
           nvPt.y := Y;
           end;
       end;
     PolyLine([ancPt,
               Point(ancPt.x,nvPt.y),
               nvPt,
               Point(nvPt.x,ancPt.y),
               ancPt]);
     Rectangle(ancPt.x-3,ancPt.y+3,ancPt.x+3,ancPt.y-3);
     Rectangle(ancPt.x-3,nvPt.y+3,ancPt.x+3,nvPt.y-3);
     Rectangle(nvPt.x-3,ancPt.y+3,nvPt.x+3,ancPt.y-3);
     Rectangle(nvPt.x-3,nvPt.y+3,nvPt.x+3,nvPt.y-3);
     end;
  Xc := coordonnees[coordonneesCourante,1]+ancPt.x/t*
      (coordonnees[coordonneesCourante,2]-coordonnees[coordonneesCourante,1]);
  Yc := coordonnees[coordonneesCourante,4]-ancPt.y/t*
      (coordonnees[coordonneesCourante,4]-coordonnees[coordonneesCourante,3]);
  Xd := coordonnees[coordonneesCourante,1]+nvPt.x/t*
      (coordonnees[coordonneesCourante,2]-coordonnees[coordonneesCourante,1]);
  Yd := coordonnees[coordonneesCourante,4]-nvPt.y/t*
      (coordonnees[coordonneesCourante,4]-coordonnees[coordonneesCourante,3]);

  if Xc > Xd then
      begin
      Aux := Xc;
      Xc  := Xd;
      Xd  := Aux
      end;

  if Yc > Yd then
      begin
      Aux := Yc;
      Yc  := Yd;
      Yd  := Aux
      end;
  FormCadre.EditXinf.Text := FloatToStr(Xc);
  FormCadre.EditXsup.Text := FloatToStr(Xd);
  FormCadre.EditYinf.Text := FloatToStr(Yc);
  FormCadre.EditYsup.Text := FloatToStr(Yd);
  end;

end;

procedure TForm1.Aproposde1Click(Sender: TObject);
begin
FormAbout.Visible := True;
end;


procedure TForm1.Aide1Click(Sender: TObject);
begin
Application.Helpjump('Sommaire');
end;



procedure TForm1.ToolButton1Click(Sender: TObject);
begin
//if not(ObjetCalcule) then
  //begin
  Calculate;
  ParametreCourant(ProgrammeCourant,StatusBar1);
  FormCadre.Visible := True;
  //end;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
if not(CadreCree) then
  begin
  VerificationPalette(TableauPalette);
  TableauPalette[PaletteCourante].pas := StrToInt(FormPalette.EditPas.Text);
  TableauPalette[PaletteCourante].style := FormPalette.ComboBoxStyle.ItemIndex;
  TableauPalette[PaletteCourante].depart :=
      Round(FormPalette.ScrollBar1.Position/100*TableauPalette[PaletteCourante].IndiceMax);
  TableauPalette[PaletteCourante].SaturationMin   := StrToFloat(FormPalette.EditSatMin.Text);
  TableauPalette[PaletteCourante].SaturationMax   := StrToFloat(FormPalette.EditSatMax.Text);

  case lEffet of
    aucun  : ;
    relief : begin
             phi := StrToFloat(FormEffet.Edit1.Text)/180*Pii;
             theta := StrToFloat(FormEffet.Edit2.Text)/180*Pii;
             aEclair := cos(theta)*cos(phi);
             bEclair := cos(theta)*sin(phi);
             cEclair := sin(theta);
             Kintensite := StrToFloat(FormEffet.Edit3.Text);
             end;
    hollowValue :
             begin
             minEffet := StrToFloat(FormEffet.Edit4.Text);
             maxEffet := StrToFloat(FormEffet.Edit5.Text);
             Kintensite := StrToFloat(FormEffet.Edit6.Text);
             end;
    end;

  DessineImage(NewPict,TableauPalette,NbPalettes,lEffet,Image1);
  end;
FormPalette.Visible := True;
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
FormRepartition.Visible := True;
//CalculRepartition(NewPict,FormRepartition.ImageRep,min,max);
CalculDistribution(NewPict,FormRepartition.ImageRep,
                   StrToFloat(FormRepartition.EditMin.Text),
                   StrToFloat(FormRepartition.EditMax.Text)) 

end;

procedure TForm1.Relief1Click(Sender: TObject);
begin
lEffet := Relief;
phi := 45/180*Pii;
theta := 45/180*Pii;
aEclair := cos(theta)*cos(phi);
bEclair := cos(theta)*sin(phi);
cEclair := sin(theta);
Kintensite := 0.1;
FormEffet.Visible := True;
FormEffet.GroupBox1.Visible := True;
FormEffet.GroupBox2.Visible := False;
end;

procedure TForm1.Hollow1Click(Sender: TObject);
begin
lEffet := hollowValue;
minEffet := 3;
maxEffet := 75;
Kintensite := 0.1;
FormEffet.Visible := True;
FormEffet.GroupBox1.Visible := False;
FormEffet.GroupBox2.Visible := True;
end;

procedure TForm1.Contrast1Click(Sender: TObject);
var minC,maxC : Double;
begin
lEffet := contrast;
//CalculeContraste(NewPict
Kintensite := 0.1;
FormEffet.Visible := True;
FormEffet.GroupBox1.Visible := False;
FormEffet.GroupBox2.Visible := True;
end;

procedure TForm1.Build1Click(Sender: TObject);
begin
//if not(CadreCree) then
  //begin
  Calculate;
  ParametreCourant(ProgrammeCourant,StatusBar1);
  FormCadre.Visible := True;
  //end;
end;

procedure TForm1.Cancel1Click(Sender: TObject);
begin
if CadreCree then
  begin
  with Form1.Image1.Canvas do
     begin
     PolyLine([ancPt,
               Point(ancPt.x,nvPt.y),
               nvPt,
               Point(nvPt.x,ancPt.y),
               ancPt]);
     Rectangle(ancPt.x-3,ancPt.y+3,ancPt.x+3,ancPt.y-3);
     Rectangle(ancPt.x-3,nvPt.y+3,ancPt.x+3,nvPt.y-3);
     Rectangle(nvPt.x-3,ancPt.y+3,nvPt.x+3,ancPt.y-3);
     Rectangle(nvPt.x-3,nvPt.y+3,nvPt.x+3,nvPt.y-3);
     end;
  end;
CadreCree := False;

BoutonEnfonce := False;
CadreModifie := -1;

FormCadre.EditXinf.Text := FloatToStr(coordonnees[coordonneesCourante,1]);
FormCadre.EditXsup.Text := FloatToStr(coordonnees[coordonneesCourante,2]);
FormCadre.EditYinf.Text := FloatToStr(coordonnees[coordonneesCourante,3]);
FormCadre.EditYsup.Text := FloatToStr(coordonnees[coordonneesCourante,4]);
//ObjetCalcule := True;


end;



end.
